# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_toComponents
		class Face_com_curver
			attr_accessor :facecom_curvers,:origin,:faces,:ins,:origin_defn,:defn,:instances,:lengths
			def initialize
				@faces=[]
				@facecom_curvers=[]
				@instances=[]
				@lengths=[]
				@origin=0
				@faces=[]
				@ins=nil
				@defn=[]
				@origin_defn=0
				@index=0
				@strings=S4U::S4u_toComponents::Strings
				@cursor_id = nil
				cursor_path = File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
				@cursor_id = UI.create_cursor(cursor_path, 0, 0) if cursor_path
			end
			def activate
				model=Sketchup.active_model
				model.start_operation(@strings["FaceCurver to Components"],true,false,false)
				result=self.get_select
				flag=true
				if result
					@faces=result[0]
					@faces.each{|f| f.hidden = true}
					model.selection.clear
					@ins=result[1]
					list=get_face_curvers(@faces)
					@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn) if !@defn[@origin_defn]
					if list	&& list.length>0
						list.each{|ls|
							if ls && ls.length>0
								facecom_curver=Hash.new
								facecom_curver["list"]=ls
								fc=set_facecom_curver(facecom_curver,0)
								@facecom_curvers<< fc if fc
							end
						}
						set_status_process(0)
						@facecom_curvers.each_index{|i|
							fi=add_facecom_curver(@facecom_curvers[i],@defn[@origin_defn])
							flag=fi if !fi
							set_status_process(1)
						}
						set_status_process(1)
					else
						flag=false
					end
				end
				model.commit_operation
				setstatus
				Sketchup.active_model.select_tool(nil) if !flag or !result
			end
			def deactivate(view)
				model=Sketchup.active_model
				model.start_operation(@strings["FaceCurver to Components"],true,false,true)
				@faces.each{|f| f.hidden = false if f && f.valid?}
				@defn.each{|d| d.entities.clear! if d.valid?}
				model.commit_operation
				rescue =>error
				p error
				p error.backtrace.join("\n")
			end
			def get_select
				model=Sketchup.active_model
				sel=model.selection
				grp=nil;ins=nil;faces=[]
				grp=sel.find{|e| e.is_a?Sketchup::Group}
				ins=sel.find{|e| e.is_a?Sketchup::ComponentInstance}
				faces=sel.select{|e| e.valid? && (e.is_a?Sketchup::Face) && e.loops.length==1}
				if faces.empty? || faces.length<2
					UI.messagebox(@strings["Selection must contain faces.(no hole)"])
					return false
				end
				if not ins
					if grp
						ins=grp.to_component
					else
						UI.messagebox(@strings["Selection must contain Component"])
						return false
					end
				end
				return [faces,ins]
			end
			def set_status_process(start=1,text=" ",process_length=@facecom_curvers.length )
				if start==0
					@process=1
				else
					if @process<=process_length and @process>=1
						Sketchup.status_text= @strings["Processing"] + "#{text} : #{@process} / #{process_length}"
						@process+=1
					else
						Sketchup.status_text=  @strings["Finishing"] + "#{text}....."
					end
				end
			end
			def setstatus(view=nil)
				Sketchup.status_text = @strings["LeftMouse(or Left,Right key) for Select origin FaceCurve.Hold Ctrl(Alt on Mac) and LeftMouse(or UP,DOWN key) for Reverse Axis"]
				view.invalidate if view!=nil
			end
			def getMenu(menu)
				menu.add_item(@strings["Finish"]){
					model=Sketchup.active_model
					model.start_operation(@strings["FaceCurver to Components"],true,false,true)
					ed=[]
					@faces.each{|f|
						if f.valid?
							f.edges.each { |e1| ed.push e1 if e1.faces and e1.faces.length==1 }
							f.erase!
						end
					}
					ed.each {|e1| e1.erase! if e1.valid?}
					model.commit_operation
					model.select_tool(nil)
				}
				rescue =>error
				p error
				p error.backtrace.join("\n")
			end
			def onSetCursor
				UI.set_cursor(@cursor_id) if @cursor_id
			end
			def onLButtonUp(flags, x, y, view)
				self.select_facecom(x, y, view)
				setstatus
			end
			def select_facecom(x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				selectface=ph.picked_face
				entity = ph.best_picked
				model=view.model
				model.start_operation(@strings["FaceCurver to Components"],true,false,false)
				fc=@facecom_curvers.find{|f| entity==f["instance"]}
				if fc
					if @ctrl_flag
						fc=reverse_add(fc)
					else
						fc=next_add(fc)
					end
				end
				model.commit_operation
			end
			def next_add(facecom_curver)
				facecom_curver["instance"].definition.entities.clear!
				facecom_curver["origin_index"]=((facecom_curver["origin_index"]==3) ? 0 : (facecom_curver["origin_index"]+1))
				@origin_defn=0
				@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn) if !@defn[@origin_defn]
				return add_facecom_curver(facecom_curver,@defn[@origin_defn])
			end
			def previous_add(facecom_curver)
				facecom_curver["instance"].definition.entities.clear!
				facecom_curver["origin_index"]=((facecom_curver["origin_index"]==0) ? 3 : (facecom_curver["origin_index"]-1))
				@origin_defn=0
				@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn) if !@defn[@origin_defn]
				return add_facecom_curver(facecom_curver,@defn[@origin_defn])
			end
			def reverse_add(facecom_curver)
					facecom_curver["instance"].definition.entities.clear!
					@origin_defn=0
					@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn) if !@defn[@origin_defn]
					facecom_curver["reverse"]=1-facecom_curver["reverse"]
					return add_facecom_curver(facecom_curver,@defn[@origin_defn])
			end
			def onKeyDown(key, repeat, flags, view)
				@ctrl_flag=true if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
				if key==VK_RIGHT
					model=view.model
					model.start_operation(@strings["FaceCurver to Components"],true,false,false)
					set_status_process(0)
					@facecom_curvers.each_index{|i|
						@facecom_curvers[i]	=next_add(@facecom_curvers[i])
						set_status_process(1)
					}
					set_status_process(1)
					model.commit_operation
				elsif ((key==9)) || ((key==48) && IS_OSX)
					model=view.model
					model.start_operation(@strings["FaceCurver to Components"],true,false,false)
					set_status_process(0)
					@facecom_curvers.each_index{|i|
						@facecom_curvers[i]	=next_add(@facecom_curvers[i])
						@facecom_curvers[i]	=reverse_add(@facecom_curvers[i])
						set_status_process(1)
					}
					set_status_process(1)
					model.commit_operation
				elsif key==VK_LEFT
					model=view.model
					model.start_operation(@strings["FaceCurver to Components"],true,false,false)
					set_status_process(0)
					@facecom_curvers.each_index{|i|
						@facecom_curvers[i]	=previous_add(@facecom_curvers[i])
						set_status_process(1)
					}
					set_status_process(1)
					model.commit_operation
				elsif key==VK_DOWN || key==VK_UP
					model=view.model
					model.start_operation(@strings["FaceCurver to Components"],true,false,false)
					set_status_process(0)
					@facecom_curvers.each_index{|i|
						@facecom_curvers[i]	=reverse_add(@facecom_curvers[i])
						set_status_process(1)
					}
					set_status_process(1)
					model.commit_operation
				end
				setstatus
			end
			def onKeyUp(key, repeat, flags, view)
				@ctrl_flag=false if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
			end
			def get_face_curvers(faces_in=@faces,start=0)
				list=[]
				faces=faces_in
				return nil if !faces
				numface=0
				while !faces.empty? && (numface<faces_in.length)
						ls=[]  ;fas=[]
						faces.each_index{|i|
							f=faces[i]
							number=0
							f.edges.each{|e| number+=1 if (e.faces & faces_in).length==1}
							fas<<f if number==3
						}
						fa=fas[start] ? fas[start] : ((start==0)? faces[0] : faces[-1])
						ls<< fa
						i=0
						while fa && (i<faces.length)
							edges=fa.edges*2
							(0..fa.edges.length-1).each{|j|
								v1=edges[j]
								v2=edges[j+1]
								f=(v1.faces & faces)
								ver_start_faces=v1.start.faces & ls
								ver_end_faces=v1.end.faces & ls
								if f.length==2 && ver_start_faces.length<=1 && ver_end_faces.length<=1
									fa=nil
									f.each{|f1|
										if not (ls.include?(f1))
											ls<< f1
											fa=f1
										end
									}
									break if fa
								end
							}
							i+=1
						end
						faces=faces-ls
						list<< ls if ls.length>1
						numface+=1
				end
				return list
			end
			def set_facecom_curver(facecom_curver,start=0)
				list=facecom_curver["list"]
				return nil if list && list.length==0
				facecoms_list=[]
				list.reverse! if start==1
				fcs=list.collect{|f| FaceCom.new(f)}
				(0..fcs.length-1).each{|i|
					facecoms=Hash.new
					facecoms["facecom"]=nil
					if fcs[i].numver==4 && fcs[i].parallel? && (fcs[i].xaxis.perpendicular? fcs[i].yaxis)
						vertices=fcs[i].vertices*2
						if i<fcs.length-1
							(0..3).each{|j|
								v1=vertices[j]
								v2=vertices[j+1]
								if fcs[i+1].vertices.include?(v1) &&  fcs[i+1].vertices.include?(v2)
									index= j==0 ? 3 : (j-1)
									fcs[i].set_origin index
									fcs[i].reverse_axis if v1!=fcs[i].vertices[1]
									break
								end
							}
						else
							(0..3).each{|j|
								v1=vertices[j]
								v2=vertices[j+1]
								if fcs[i-1].vertices.include?(v1) && fcs[i-1].vertices.include?(v2)
									id=fcs[i-1].vertices.index(v1)
									if id==1
										index=0
										fcs[i].set_origin index
										fcs[i].reverse_axis if v2!=fcs[i].vertices[1]
									else
										index= (j==3) ? 0 : (j+1)
										fcs[i].set_origin index
										fcs[i].reverse_axis if v1==fcs[i].vertices[1]
									end
									break
								end
							}
						end
						facecoms["facecom"]=fcs[i]
					end
					(facecoms_list<<facecoms) if facecoms["facecom"]
				}
				return nil if facecoms_list.length<2
				facecom_curver["facecoms"]=facecoms_list
				facecom_curver["list"]=list
				facecom_curver["reverse"]=0
				facecom_curver["origin_index"]=0
				return facecom_curver
			end
			def setvar_facecom_curver(facecom_curver,index_origins)
				model=Sketchup.active_model
				tmpins=model.active_entities.add_instance @ins.definition,Geom::Transformation.new
				d=tmpins.bounds.max.z
				model.active_entities.erase_entities tmpins
				fcs=facecom_curver["facecoms"]
				return nil if fcs && fcs.length==0
				vers=fcs[0]["facecom"].vertices*2
				index_origin = index_origins[0]
				index_origin1= index_origins[1]
				index_origin2= index_origins[2]
				index_origin_1= index_origins[-1]
				length=0;length1=0;depths=[]
				(0..fcs.length-2).each{|i|
					v1=fcs[i]["facecom"].vertices[index_origin].position.vector_to fcs[i]["facecom"].vertices[index_origin1].position
					v=fcs[i]["facecom"].vertices[index_origin].position.vector_to fcs[i]["facecom"].vertices[index_origin_1].position
					normal=v1.cross v
					v2=fcs[i+1]["facecom"].vertices[index_origin].position.vector_to fcs[i+1]["facecom"].vertices[index_origin1].position
					line=[fcs[i]["facecom"].vertices[index_origin].position,v1]
					point=fcs[i+1]["facecom"].vertices[index_origin1].position.project_to_line line
					a=1
					if point!=fcs[i+1]["facecom"].vertices[index_origin1].position
						if not (v1.samedirection? v2)
							a=1
							vec=point.vector_to fcs[i+1]["facecom"].vertices[index_origin1].position
							a= (vec.samedirection? normal) ? -1 : 1
						end
					end
					ang=v1.reverse.angle_between v2
					d1=a*d*Math.tan(Math::PI*0.5-ang*0.5)
					depths<<[d1,a,(ang*0.5)]
					l=(fcs[i]["facecom"].vertices[index_origin].position.distance fcs[i]["facecom"].vertices[index_origin1].position)
					fcs[i]["distance"]=length
					length+= (2*d1+l)
					fcs[i]["convex"]=a
					fcs[i]["corner"]=d1
					fcs[i]["angle"]=ang*0.5
					fcs[i]["length"]=l
				}
				l=fcs[-1]["facecom"].vertices[index_origin].position.distance fcs[-1]["facecom"].vertices[index_origin1].position
				length+= l
				fcs[-1]["length"]=l
				fcs[-1]["distance"]=length-l
				facecom_curver["facecoms"]=fcs
				facecom_curver["length"]=length
				plane=nil
				(0..fcs.length-2).each{|i|
					v1=fcs[i]["facecom"].vertices[index_origin].position.vector_to fcs[i]["facecom"].vertices[index_origin1].position
					v=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin2].position
					line =[fcs[i]["facecom"].vertices[index_origin1].position,v]
					a= fcs[i]["convex"]>=0 ? -fcs[i]["angle"]: fcs[i]["angle"]
					new_vector=v1.transform(Geom::Transformation.rotation(line[0],v,a))
					plane=(a<0) ? [line[0],(new_vector.cross line[1])] : [line[0],(new_vector.cross line[1]).reverse]
					fcs[i]["cutplane"]=plane
				}
				return facecom_curver
			end
			def add_facecom_curver(facecom_curver,defn=@defn[@origin_defn])
				model=Sketchup.active_model
				origin_index=facecom_curver["origin_index"]
				reverse=facecom_curver["reverse"]
				facecom_curver=set_facecom_curver(facecom_curver,0)
				return nil if !facecom_curver
				fcs=facecom_curver["facecoms"]
				fcs.each{|f|
					f["facecom"].set_origin(origin_index)
					f["facecom"].origin_index=0
				}
				case origin_index
				when 0
					if reverse==0
							a=[0,1,2,3]*2
							index_origins=a[(4-origin_index),4]
							index_origin = index_origins[0]
							index_origin1= index_origins[1]
							index_origin2= index_origins[2]
							index_origin_1= index_origins[-1]
							facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
							fcs=facecom_curver["facecoms"]
							set_status_process(0,@strings["add FaceCurver"],fcs.length)
							(0..fcs.length-1).each{|i|
									origin=fcs[i]["facecom"].vertices[index_origin].position
									fcs[i]["facecom"].insert_instance defn
									l=fcs[i]["length"]
									ratio= facecom_curver["length"]/ l
									ts= Geom::Transformation.scaling(ratio,1,1)
									group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance)
									group.transformation=group.transformation*ts
									#vec1=group.transformation.origin.vector_to origin
									#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
									vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
									vec.length=fcs[i]["distance"] if i>0
									group.transform! Geom::Transformation.translation(vec) if i>0
									fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
									if i>0
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
									end
									if (i< fcs.length-1)
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
									end
									set_status_process(1,@strings["add FaceCurver"],fcs.length)
							}
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						else #rever=1
							fcs.each{|f| f["facecom"].reverse_axis}
							a=[0,1,2,3]*2
							index_origins=[a[origin_index]] + a[origin_index+1,3].reverse
							index_origin = index_origins[0]
							index_origin1= index_origins[1]
							index_origin2= index_origins[2]
							index_origin_1= index_origins[-1]
							facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
							fcs=facecom_curver["facecoms"]
							set_status_process(0,@strings["add FaceCurver"],fcs.length)
							(0..fcs.length-1).each{|i|
									origin=fcs[i]["facecom"].vertices[index_origin].position
									fcs[i]["facecom"].insert_instance defn
									l=fcs[i]["length"]
									ratio= facecom_curver["length"]/ l
									ts= Geom::Transformation.scaling(1,ratio,1)
									fcs[i]["facecom"].instance.transformation=fcs[i]["facecom"].instance.transformation*ts
									group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance)
									#vec1=group.transformation.origin.vector_to origin
									#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
									vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
									vec.length=fcs[i]["distance"] if i>0
									group.transform! Geom::Transformation.translation(vec) if i>0
									fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
									if i>0
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
									end
									if (i< fcs.length-1)
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
									end
									set_status_process(1,@strings["add FaceCurver"],fcs.length)
							}
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						end
				when 2
					if reverse==0
						a=[0,1,2,3]*2
						index_origins=a[(4-origin_index),4]
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
								origin=fcs[i]["facecom"].vertices[index_origin].position
								fcs[i]["facecom"].insert_instance defn
								l=fcs[i]["length"]
								ratio= facecom_curver["length"]/ l
								ts= Geom::Transformation.scaling(ratio,1 ,1)
								group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_xy")
								group.transformation=group.transformation*ts
								#vec1=group.transformation.origin.vector_to origin
								#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
								vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
								vec.length=fcs[i]["distance"] if i>0
								group.transform! Geom::Transformation.translation(vec) if i>0
								fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
								if i>0
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
									end
									if (i< fcs.length-1)
										dt=fcs[i]["facecom"].instance.definition
										(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
										dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
								end
								set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					else #rever=1
						fcs.each{|f| f["facecom"].reverse_axis}
						a=[0,1,2,3]*2
						index_origins=[a[origin_index]] + a[origin_index+1,3].reverse
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
							origin=fcs[i]["facecom"].vertices[index_origin].position
							fcs[i]["facecom"].insert_instance defn
							l=fcs[i]["length"]
							ratio= facecom_curver["length"]/ l
							ts= Geom::Transformation.scaling(1,ratio,1)
							group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_xy")
							group.transformation=group.transformation*ts
							#vec1=group.transformation.origin.vector_to origin
							#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
							vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
							vec.length=fcs[i]["distance"] if i>0
							group.transform! Geom::Transformation.translation(vec) if i>0
							fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
							if i>0
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							if (i< fcs.length-1)
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					end
				when 1
					if reverse==0
						a=[0,1,2,3]*2
						index_origins=a[(4-origin_index),4]
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
							origin=fcs[i]["facecom"].vertices[index_origin].position
							fcs[i]["facecom"].insert_instance defn
							l=fcs[i]["length"]
							ratio= facecom_curver["length"]/ l
							ts= Geom::Transformation.scaling(1,ratio,1)
							group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_y")
							group.transformation=group.transformation*ts
							#vec1=group.transformation.origin.vector_to origin
							#group.transform! Geom::Transformation.translation(vec1)#if i<fcs.length-1
							vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
							vec.length=fcs[i]["distance"] if i>0
							group.transform! Geom::Transformation.translation(vec) if i>0
							fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
							if i>0
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							if (i< fcs.length-1)
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					else #rever=1
						fcs.each{|f| f["facecom"].reverse_axis}
						a=[0,1,2,3]*2
						index_origins=[a[origin_index]] + a[origin_index+1,3].reverse
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
							origin=fcs[i]["facecom"].vertices[index_origin].position
							fcs[i]["facecom"].insert_instance defn
							l=fcs[i]["length"]
							ratio= facecom_curver["length"]/ l
							ts= Geom::Transformation.scaling(ratio,1,1)
							group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_x")
							group.transformation=group.transformation*ts
							#vec1=group.transformation.origin.vector_to origin
							#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
							vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
							vec.length=fcs[i]["distance"] if i>0
							group.transform! Geom::Transformation.translation(vec) if i>0
							fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
							if i>0
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							if (i< fcs.length-1)
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					end
				when 3
					if reverse==0
						a=[0,1,2,3]*2
						index_origins=a[1,4]
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
							origin=fcs[i]["facecom"].vertices[index_origin].position
							fcs[i]["facecom"].insert_instance defn
							l=fcs[i]["length"]
							ratio= facecom_curver["length"]/ l
							ts= Geom::Transformation.scaling(1,ratio,1)
							group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_x")
							group.transformation=group.transformation*ts
							#vec1=group.transformation.origin.vector_to origin
							#group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
							vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
							vec.length=fcs[i]["distance"] if i>0
							group.transform! Geom::Transformation.translation(vec) if i>0
							fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
							if i>0
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							if (i< fcs.length-1)
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					else #rever=1
						fcs.each{|f| f["facecom"].reverse_axis}
						a=[0,1,2,3]*2
						index_origins=[a[origin_index]] + a[origin_index+1,3].reverse
						index_origin = index_origins[0]
						index_origin1= index_origins[1]
						index_origin2= index_origins[2]
						index_origin_1= index_origins[-1]
						facecom_curver=setvar_facecom_curver(facecom_curver,index_origins)
						fcs=facecom_curver["facecoms"]
						return nil if fcs.empty?
						set_status_process(0,@strings["add FaceCurver"],fcs.length)
						(0..fcs.length-1).each{|i|
							origin=fcs[i]["facecom"].vertices[index_origin].position
							fcs[i]["facecom"].insert_instance defn
							l=fcs[i]["length"]
							ratio= facecom_curver["length"]/ l
							ts= Geom::Transformation.scaling(ratio,1,1)
							fcs[i]["facecom"].instance.transformation=fcs[i]["facecom"].instance.transformation*ts
							group=S4U::S4u_toComponents.create_group(fcs[i]["facecom"].instance,"max_y")
							vec1=group.transformation.origin.vector_to origin
							group.transform! Geom::Transformation.translation(vec1)	#if i<fcs.length-1
							vec=fcs[i]["facecom"].vertices[index_origin1].position.vector_to fcs[i]["facecom"].vertices[index_origin].position
							vec.length=fcs[i]["distance"] if i>0
							group.transform! Geom::Transformation.translation(vec) if i>0
							fcs[i]["facecom"].instance=group.explode.grep(Sketchup::ComponentInstance)[0]
							if i>0
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i-1]["cutplane"]],1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							if (i< fcs.length-1)
								dt=fcs[i]["facecom"].instance.definition
								(fcs[i]["facecom"].instance=S4U::S4u_toComponents.cut_elements([fcs[i]["facecom"].instance],[fcs[i]["cutplane"]],-1,1).grep(Sketchup::ComponentInstance)[0])
								dt.entities.clear! if dt!=fcs[i]["facecom"].instance.definition and dt.instances.length==1
							end
							set_status_process(1,@strings["add FaceCurver"],fcs.length)
						}
						set_status_process(1,@strings["add FaceCurver"],fcs.length)
					end
				end
				facecom_curver["origin_index"]=origin_index
				facecom_curver["reverse"]=reverse
				g=Sketchup.active_model.active_entities.add_group fcs.collect{|fc| fc["facecom"].instance}
				ins=g.entities.select{|ins| ins.is_a?Sketchup::ComponentInstance}
				defn=ins.collect{|d| d.definition }
				ins.each{|i| i.explode }
				defn.each{|d| d.entities.clear! if d}
				g=g.to_component
				facecom_curver["instance"]=g
				return facecom_curver
			end
		end
		class FacetoComponents
			attr_accessor :faces,:facecoms,:ins,:defn,:defn1,:origin_defn,:bounds_ins,:defnlist,:inslist,:display_axis,:defn_added,:arrange
			def initialize(display_axis=true,arrange=false,uniform=false)
				@faces=[];@facecoms=[];@defnlist=[];@defn_polygon=[];@defn=[];@inslist=[];@defn1=[];@defn_added=[]
				@origin_defn=0 ;@origin_defn1=0
				@display_axis=display_axis;@arrange=arrange
				@ctrl_flag=false
				@uniform=uniform
				@select_uniform=false
				@strings=S4U::S4u_toComponents::Strings
				@cursor_id = nil
				cursor_path = File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
				@cursor_id = UI.create_cursor(cursor_path, 0, 0) if cursor_path
			end
			def activate
				model=Sketchup.active_model
				@list=[];
				@unit=nil
				@unit_polygon=nil
				model.definitions.each{|d| @list<< d}
				Sketchup.active_model.select_tool(nil) if not self.setvar
			end
			def deactivate(view)
				main_process(false) if !@cancel
				model=Sketchup.active_model
				model.start_operation(@strings["Faces to Components-clean_defn"],true,false,true)
				if @ins
					@defn.each{|d| d.entities.clear! if d && !d.deleted? }
					@defn1.each{|d| d.entities.clear! if d && !d.deleted? }
					@defn_added.each{|d| d[0].entities.clear! if (d[0].valid? && (d[0].count_instances<1)) }
				end
				listend=[]
				model.definitions.each{|d| listend<< d }
				listend=listend-@list
				listend.each{|d| d.entities.clear! if d.valid? and d.count_instances<1	}
				model.commit_operation
				rescue =>error
				p error
				p error.backtrace.join("\n")
				model.abort_operation
			end
			def get_select
				model=Sketchup.active_model
				sel=model.selection
				grp_ins=nil
				grp=sel.find{|e| e.is_a?Sketchup::Group}
				@ins=sel.find{|e| e.is_a?Sketchup::ComponentInstance}
				@faces=sel.select{|e| e.valid? && (e.is_a?Sketchup::Face) && e.loops.length==1}
				if @faces.empty?
					UI.messagebox(@strings["Selection must contain faces.(no hole)"])
					return false
				end
				if (!@ins) && (!grp) && (!@display_axis) && (!@arrange) && (!@uniform)
					UI.messagebox(@strings["Selection must contain Component or Group"])
					return false
				end
				result=true
				if !@ins && grp
					grp_ins=grp.to_component
					@ins=grp_ins
				end
				@bounds_ins=S4U::S4u_toComponents.get_bounds(@ins) if @ins
				return result
			end
			def onSetCursor
				UI.set_cursor(@cursor_id) if @cursor_id
			end
			def setvar
				model=Sketchup.active_model
				view= model.active_view
				@ctrl_flag=false
				flag=false
				model.start_operation(@strings["Faces to Components"],true,false,false)
				@edit_transform=S4U::S4u_toComponents::axes_edit_transform
				result=self.get_select
				result ? model.commit_operation : model.abort_operation
				if result
					@faces.each{|f| @facecoms<< FaceCom.new(f) }
					if @arrange or @uniform
						model.start_operation(@strings["Faces to Components"],true,false,true)
						@facecoms.each{|f| S4U::S4u_toComponents.minline_facecom(f)} if @uniform
						@facecoms.each{|f| S4U::S4u_toComponents.arrange_facecom(f)} if @arrange
						model.commit_operation
						self.main_process
					else
						if @display_axis
							model.start_operation(@strings["Faces to Components"],true,false,true)
							@facecoms[1..-1].each{|f| f.draw_origin(view) }
							@facecoms[0].draw_origin(view,true)
							model.commit_operation
							self.setstatus(view)
						else # interact
							@facecoms=@facecoms.select{|f| f.numver<=4 }
							set_status_process(0)
							model.start_operation(@strings["Faces to Components"],true,false,true)
							@facecoms.each{|f| set_status_process; self.get_instance(f)}
							model.commit_operation
							set_status_process
						end
						flag=true
					end
				end
				return flag
			end
			def getMenu(menu)
				model=Sketchup.active_model
				if @display_axis
					menu.add_item(@strings["Arrange origin"]) {
						model.start_operation(@strings["Faces to Components-Axis"],true,false,true)
						set_status_process(0)
						if @select_uniform
							@defnlist.each{|f| f.definition.entities.clear! if f.definition }
							@defnlist.clear
							@select_uniform=false
						end
						@facecoms.each{|f|
							set_status_process(1,@strings["Arrange origin"])
							f=S4U::S4u_toComponents.arrange_facecom(f)
							#f=S4U::S4u_toComponents.angle_facecom(f)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Arrange origin"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Max Angle Origin"]) {
						model.start_operation(@strings["Faces to Components-Axis"],true,false,true)
						set_status_process(0)
						if @select_uniform
							@defnlist.each{|f| f.definition.entities.clear! if f.definition }
							@defnlist.clear
							@select_uniform=false
						end
						@facecoms.each{|f|
							set_status_process(1,@strings["Max Angle Origin"])
							f=S4U::S4u_toComponents.angle_facecom(f)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Max Angle Origin"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Min Line to X-axis"]) {
						model.start_operation(@strings["Faces to Components-Axis"],true,false,true)
						set_status_process(0)
						if @select_uniform
							@defnlist.each{|f| f.definition.entities.clear! if f.definition }
							@defnlist.clear
							@select_uniform=false
						end
						@facecoms.each{|f|
							set_status_process(1,@strings["Min Line to X-axis"])
							f=S4U::S4u_toComponents.minline_facecom(f)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Min Line to X-axis"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Texture origin"]) {
						model.start_operation(@strings["Faces to Components-Axis"],true,false,true)
						set_status_process(0)
						@defnlist.each{|f| f.definition.entities.clear! if f.definition }
						@defnlist.clear
						@select_uniform=false
						@facecoms.each{|f|
							set_status_process(1,@strings["Texture origin"])
							f=S4U::S4u_toComponents.texture_facecom(f)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Texture origin"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Find Uniform"]) {
						model.start_operation(@strings["Faces to Components-Axis"],true,false,true)
						@defnlist.each{|f| f.definition.entities.clear! if f.definition}
						@defnlist.clear
						@select_uniform=true
						set_status_process(0)
						@facecoms.each{|f|
							set_status_process(1,@strings["Find Uniform"])
							#f=S4U::S4u_toComponents.minline_facecom(f)
							self.get_definition(f,true)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Find Uniform"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Finish"]){ self.main_process}
				else
					menu.add_item(@strings["Arrange origin components"]) {
						model.start_operation(@strings["Faces to Components"],true,false,true)
						set_status_process(0)
						@facecoms.each{|f|
							set_status_process(1,@strings["Arrange origin components"])
							f.instance.erase! if f.instance
							S4U::S4u_toComponents.arrange_facecom(f)
							self.get_instance f
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Arrange origin components"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Min line xaxis components"]) {
						model.start_operation(@strings["Faces to Components"],true,false,true)
						set_status_process(0)
						@facecoms.each{|f|
							set_status_process(1,@strings["Min line xaxis components"])
							f.instance.erase! if f.instance
							S4U::S4u_toComponents.minline_facecom(f)
							self.get_instance f
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Min line xaxis components"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Max angle origin components"]) {
						model.start_operation(@strings["Faces to Components"],true,false,true)
						set_status_process(0)
						@facecoms.each{|f|
							set_status_process(1,@strings["Max angle origin components"])
							f.instance.erase! if f.instance
							S4U::S4u_toComponents.angle_facecom(f)
							self.get_instance f
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Max angle origin components"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Find uniform components"]) {
						model.start_operation(@strings["Faces to Components"],true,false,true)
						@defn_added.each{|d|  d[0].entities.clear! if d[0].valid?}
						@inslist.clear
						@defn_added.clear
						@facecoms.each{|f| f.instance.erase! if f.instance }
						@facecoms.each{|f|
							set_status_process(1,@strings["Find uniform components"])
							#f=S4U::S4u_toComponents.minline_facecom(f)
							self.get_instance(f,true)
							model.selection.add f.face,f.face.edges
						}
						set_status_process(1,@strings["Find uniform components"])
						model.commit_operation
						self.setstatus(Sketchup.active_model.active_view)
					}
					menu.add_item(@strings["Finish"]){ self.main_process}
				end
			end
			def main_process(cancel=true)
				model=Sketchup.active_model
				model.start_operation @strings["Faces to Components"],true,false,true
				if @select_uniform
					@defnlist.each{|f| f.definition.entities.clear! if f.definition }
					@defnlist.clear
					@select_uniform=false
				end
				if @display_axis or @arrange or @uniform
					if not @select_uniform or @uniform
						set_status_process(0)
						@defnlist.each{|f| f.definition.entities.clear! if f.definition }
						@defnlist.clear
						@facecoms.each{|f|
							set_status_process(1,@strings["Get Definitions"])
							self.get_definition(f,@uniform)
						}
						set_status_process(1,@strings["Get Definitions"])
					end
					if @ins and (@display_axis or @arrange or @uniform)
						if  @defn[@origin_defn]==nil
							@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn)
						end
						self.insert_defn @defn[@origin_defn]
						@defn[@origin_defn].entities.clear!
					else
						model.commit_operation
						model.start_operation @strings["Faces to Components"],true,false,false
						set_status_process(0)
						@facecoms.each{|f|
							set_status_process(1,@strings["Creat Components"])
							f.add_ins
						}
						set_status_process(1,@strings["Creat Components"])
					end
				end
				if cancel
				ed=[]
				@facecoms.each{|f|
					if f.face.valid?
						f.face.edges.each { |e1|  ed.push e1 if e1.faces and e1.faces.length==1 }
						f.face.erase!
					end
				}
				ed.each {|e1| e1.erase! if e1.valid?}
				end
				model.commit_operation
				@cancel=true
				model.select_tool(nil)
			end
			def setstatus(view)
				if @dislay_axis
					Sketchup.status_text = @strings["LeftMouse for Select origin Faces or origin Components.Hold Ctrl(Alt on Mac) and LeftMouse for Reverse Axis.RightMouse for Arrange origin Faces or Finish.Enter for Finish"]
				else
					Sketchup.status_text = @strings["LeftMouse on Component for select origin Components.Hold Ctrl(Alt on Mac) and LeftMouse for Reverse Axis.RightMouse for Arrange origin Component or Finish.Enter for Finish"]
				end
				view.invalidate if view!=nil
			end
			def set_status_process(start=1,text=" ")
				if start==0
					@process=1
				else
					process_length=@facecoms.length
					if @process<=process_length and @process>=1
						Sketchup.status_text= @strings["Processing"] + " #{text} :  #{@process} / #{process_length}"
						@process+=1
					else
						Sketchup.status_text= @strings["Finishing"] + " #{text}  ........."
					end
				end
			end
			def draw(view)
				self.draw_origin_ins(view)
				(@facecoms[1..-1].each{|f| f.draw_origin(view) } ; @facecoms[0].draw_origin(view,true)) if @display_axis
				self.setstatus(view)
			end
			def draw_origin_ins (view)
				if @ins
					b=@bounds_ins[0]
					t=@ins.transformation
					origin=@bounds_ins[1]
					x=origin.transform(Geom::Transformation.translation(t.xaxis))
					y=origin.transform(Geom::Transformation.translation(t.yaxis))
					z=origin.transform(Geom::Transformation.translation(t.zaxis))
					vx=origin.vector_to x;  vx.length=b[0] if b[0]>0
					vy=origin.vector_to y;  vy.length=b[1] if b[1]>0
					vz=origin.vector_to z;  vz.length=b[2] if b[2]>0
					x=origin.transform(Geom::Transformation.translation(vx))
					y=origin.transform(Geom::Transformation.translation(vy))
					z=origin.transform(Geom::Transformation.translation(vz))
					if @origin_defn==1
						origin=x
						vx.length=vx.length*1.2
						vy.length=vy.length*1.2
						vz.length=vz.length*1.2
						x1=origin.transform(Geom::Transformation.translation vy)
						y1=origin.transform(Geom::Transformation.translation vx.reverse)
						z1=origin.transform(Geom::Transformation.translation vz)
					elsif @origin_defn==2
						origin=x.transform(Geom::Transformation.translation vy)
						vx.length=vx.length*1.2
						vy.length=vy.length*1.2
						vz.length=vz.length*1.2
						x1=origin.transform(Geom::Transformation.translation vx.reverse)
						y1=origin.transform(Geom::Transformation.translation vy.reverse)
						z1=origin.transform(Geom::Transformation.translation vz)
					elsif @origin_defn==3
						origin=y
						vx.length=vx.length*1.2
						vy.length=vy.length*1.2
						vz.length=vz.length*1.2
						x1=origin.transform(Geom::Transformation.translation vy.reverse)
						y1=origin.transform(Geom::Transformation.translation vx)
						z1=origin.transform(Geom::Transformation.translation vz)
					else
						vx.length=vx.length*1.2
						vy.length=vy.length*1.2
						vz.length=vz.length*1.2
						x1=origin.transform(Geom::Transformation.translation vx)
						y1=origin.transform(Geom::Transformation.translation vy)
						z1=origin.transform(Geom::Transformation.translation vz)
					end
					view.line_width = 5
					view.drawing_color = "red"
					view.draw_line origin,x1
					view.drawing_color = "green"
					view.draw_line origin,y1
					view.drawing_color = "blue"
					view.draw_line origin,z1
				end
			end
			def onLButtonUp(flags, x, y, view)
				model=Sketchup.active_model
				model.start_operation(@strings["Faces to Components"],true,false,true)
				self.select_origin(x, y, view)
				self.setstatus(view)
				model.commit_operation
			end
			def onLButtonDoubleClick(flags, x, y, view)
				model=Sketchup.active_model
				model.start_operation(@strings["Faces to Components"],true,false,true)
				if @display_axis
					self.reverse_origin(x, y, view)
					self.setstatus(view)
				end
				model.commit_operation
			end
			def reverse_origin(x, y, view)
				index_face=nil
				ph = view.pick_helper
				ph.do_pick x,y
				selectface=ph.picked_face
				index_face=@faces.index(selectface)
				if index_face
					@facecoms[index_face].reverse_axis
					@facecoms[index_face].draw_origin view
					return true
				else
					return false
				end
			end
			def select_origin(x, y, view)
				index_ver=nil
				index_face=nil
				ph = view.pick_helper
				ph.do_pick x,y
				selectface=ph.picked_face
				entity = ph.best_picked
				index_face=@faces.index(selectface)
				if @display_axis
					if index_face
						picked=nil;ve=nil;index_ver=nil
						ve=@facecoms[index_face].vertices.find{|v|  ph.test_point(v.position,x,y,70) }
						if ve
							index_ver=@facecoms[index_face].vertices.index(ve)
							facecoms[index_face].set_origin index_ver if index_ver
						end
						facecoms[index_face].draw_origin view
					end
					if  entity==@ins
						@origin_defn=@origin_defn+1
						@origin_defn=@origin_defn.divmod(4)[1]
					end
				else
					fc=@facecoms.find{|f| entity==f.instance }
					if fc
						fc.instance.erase!
						fc.next_origin
						fc.reverse_axis if @ctrl_flag
						self.get_instance(fc)
					end
				end
			end
			def resume(view)
				self.setstatus(view)
			end
			def onKeyUp(key, repeat, flags, view)
				self.main_process if key==13
				@ctrl_flag=false if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
			end
			def onKeyDown(key, repeat, flags, view)
				@ctrl_flag=true if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
			end
			def onCancel(reason, view)
				model=Sketchup.active_model
				model.start_operation(@strings["Faces to Components"],true,true,true)
				if not @display_axis
					@facecoms.each{|f| f.instance.erase! if f.instance.valid? }
				end
				model.commit_operation
				@cancel=true
				model.select_tool(nil)
			end
			def get_instance(fc,uniform=false)
				if ( fc.numver==4 and fc.parallel?) or fc.numver==3
					if  @defn[@origin_defn]==nil
						@defn[@origin_defn]=S4U::S4u_toComponents.get_defn(@ins,@origin_defn)
					end
					fc.insert_instance @defn[@origin_defn]
				else
					if fc.numver<=4
						fc_inslist=nil
						fc_inslist=self.find_ins(fc,uniform)
						if fc_inslist!=nil
							if fc_inslist[1]==fc
								b=fc_inslist[3]
								fc.insert_instance fc_inslist[0],b.width,b.height
							else
								b=fc_inslist[3]
								fc.insert_instance fc_inslist[0],b.width,b.height
								@defn_added << [fc.definition,fc,fc_inslist[2],b]
						   end
						else
							if  @defn1[@origin_defn1]==nil
								de=S4U::S4u_toComponents.get_defn(@ins,@origin_defn1)
							else
								de=@defn1[@origin_defn1]
							end
							if uniform
								fc=S4U::S4u_toComponents.arrange_facecom(fc)
							end
							ins=fc.create_ins(de)
							@defn_added << [fc.definition,fc,self.get_unit(fc),ins[1]]
							@inslist << fc
						end
					end
				end
				return fc
			end
			def find_ins(fc,uniform)
				if not uniform
					v1=self.get_unit(fc)
					@defn_added.each{|add| return add if add[2]==v1 }
					(0..@inslist.length-1).each{|i|
						fc_tmp=@inslist[i]
						if fc_tmp!=fc
							v2=self.get_unit(fc_tmp)
							return [@inslist[i],v2] if v1==v2
						end
					}  #end
				else
					(0..fc.numver-1).each{|i1|
						v1=self.get_unit(fc)
						@defn_added.each{|add| return add if add[2]==v1 }
						(0..@inslist.length-1).each{|i|
							fc_tmp=@inslist[i]
							if fc_tmp!=fc
								v2=self.get_unit(fc_tmp)
								return [@inslist[i],v2] if v1==v2
							end
						}  #end
						fc.next_origin
					}
					fc.reverse_axis
					(0..fc.numver-1).each{|i1|
						v1=self.get_unit(fc)
						@defn_added.each{|add| return add  if add[2]==v1 }
						(0..@inslist.length-1).each{|i|
							fc_tmp=@inslist[i]
							if fc_tmp!=fc
								v2=self.get_unit(fc_tmp)
								return [@inslist[i],v2] if v1==v2
							end
						}  #end
						fc.next_origin
					}
				end #end if uniform
				return nil
			end #end def
			def get_definition(fc,uniform=false)
				defn=nil
				if fc.polygon and fc.numver!=3 and fc.numver!=4 #and @display_axis
					if @defn_polygon[fc.numver] !=nil
						defn= @defn_polygon[fc.numver]
					else
						defn= self.create_defn fc
						@defn_polygon[fc.numver]=defn
					end
				else
					de=self.find_defn(fc,uniform)
					if de
						defn=de
					else
						#fc=S4U::S4u_toComponents.arrange_facecom(fc) if uniform
						defn= self.create_defn fc
						fc.definition=defn
						@defnlist<<fc
					end
				end
				fc.definition=defn
				return defn
			end
			def find_defn(fc,uniform=false)
				if(fc.numver==4 and fc.parallel?) or fc.numver==3
					(0..@defnlist.length-1).each{|i|
						fc_tmp=@defnlist[i]
						return @defnlist[i].definition if (fc_tmp.parallel? or fc_tmp.numver==3) and (fc_tmp.numver==fc.numver)
					}
				else
					if not uniform
						v1=self.get_unit(fc)
						(0..@defnlist.length-1).each{|i|
							fc_tmp=@defnlist[i]
							if fc!=fc_tmp
								v2=self.get_unit(fc_tmp)
								return @defnlist[i].definition if v1==v2
							end
						}
					else
						(0..fc.numver-1).each{|i1|
							v1=self.get_unit(fc)
							(0..@defnlist.length-1).each{|i|
								fc_tmp=@defnlist[i]
								if fc!=fc_tmp
									v2=self.get_unit(fc_tmp)
									return @defnlist[i].definition if v1==v2
								end
							}
							fc.next_origin
						}
						fc.reverse_axis
						(0..fc.numver-1).each{|i1|
							v1=self.get_unit(fc)
							(0..@defnlist.length-1).each{|i|
								fc_tmp=@defnlist[i]
								if fc!=fc_tmp
									v2=self.get_unit(fc_tmp)
									return @defnlist[i].definition	if v1==v2
								end
							}
							fc.next_origin
						}
					end #end if uniform
				end #end if
				return nil
			end #end def
			def create_defn(fc)
				model=Sketchup.active_model
				defn=nil
				ents=Sketchup.active_model.active_entities
				g=ents.add_group
				f=nil;tmpins=nil
				if fc.numver==3
					@unit=(fc.vertices[0].position.distance fc.vertices[1].position) if !@unit
					@unity=(fc.vertices[0].position.distance fc.vertices[-1].position) if !@unity
					f=g.entities.add_face( [0,0,0],[@unit,0,0],[0,@unity,0])
					f.reverse!
				else
					if fc.numver==4 and fc.parallel?
						@unit=(fc.vertices[0].position.distance fc.vertices[1].position) if !@unit
						@unity=(fc.vertices[0].position.distance fc.vertices[-1].position) if !@unity
						f=g.entities.add_face( [0,0,0],[@unit,0,0],[@unit,@unity,0],[0,@unity,0])
						f.reverse!
					else #    number>=5
						if fc.polygon
							dist=fc.origin.distance fc.vertices[0].position
							@unit_polygon=dist if !@unit_polygon
							ngon= g.entities.add_ngon [0,0,0], [0,0,1], @unit_polygon, fc.numver
							f=g.entities.add_face ngon
							f.reverse!
						else
							@unit1=(fc.vertices[0].position.distance fc.vertices[1].position) if !@unit1
							trans=Geom::Transformation.new(fc.xaxis,fc.yaxis,fc.zaxis,fc.origin)
							g.transformation=trans
							vers=[]
							vers=fc.vertices.collect{|v| v.position.transform trans.inverse}
							gf=g.entities.add_group
							f=gf.entities.add_face vers
							f.reverse!
							gf=S4U::S4u_toComponents.scale_unit(gf,@unit1)
							gf.explode
						end
					end
				end
				tmpins=g.to_component
				if tmpins
					defn=tmpins.definition
					ents.erase_entities tmpins
				end
				return defn
			end
			def get_unit(fc)
				if fc.unit_ver.length>0
					unit_fc=nil
					unit_fc= fc.unit_ver[fc.origin_index+ fc.rever*fc.numver]
					return unit_fc if unit_fc and unit_fc.length>0
				end
				fc.get_unit_ver
				return fc.unit_ver[fc.origin_index+ fc.rever*fc.numver]
			end
			def insert_defn(defn)
				ents=Sketchup.active_model.active_entities
				set_status_process(0)
				@facecoms.each{|fc|
					if  fc.parallel?  or fc.numver==3
						v1=fc.vertices[0].position;v2=fc.vertices[1].position
						vend=fc.vertices[fc.numver-1].position
						v1v2=v1.distance v2
						v1vend=v1.distance vend
						dx = v1v2/ (defn.bounds.width >0 ? defn.bounds.width : 1)
						dy = v1vend/ (defn.bounds.height >0 ?defn.bounds.height : 1)
						trans = Geom::Transformation.new(fc.xaxis,fc.yaxis,fc.zaxis,fc.origin)
						s=Geom::Transformation.scaling(dx,dy,1)
						insadd=ents.add_instance(defn,trans*s)
						insadd.material = fc.face.material ? fc.face.material : fc.face.back_material
						insadd.explode
						fc.definition.entities.clear!
						fc.definition=nil
					else
						fc.add_ins
					end
					set_status_process(1,@strings["Creat Components"])
				}
				set_status_process(1,@strings["Creat Components"])
				@defnlist.each{|fc|
					if fc.numver==4 and not fc.parallel?
						transfc=fc.definition.instances[0].transformation
						defn= S4U::S4u_toComponents.get_defn(@ins,@origin_defn)
						v1=fc.vertices[0].position;v2=fc.vertices[1].position
						v3=fc.vertices[2].position;v4=fc.vertices[3].position
						v1v2=v1.distance v2
						v1v4=v1.distance v4
						v1_v2 =v1.vector_to v2
						vx=v1.vector_to v2
						vy=v1.vector_to v4
						dx = v1v2/ (defn.bounds.width >0 ? defn.bounds.width : 1)
						dy = v1v4/ (defn.bounds.height >0 ?defn.bounds.height : 1)
						trans = Geom::Transformation.new(vx,vy,fc.zaxis,v1)
						s=Geom::Transformation.scaling(dx,dy,1)
						fc.definition.entities.clear!
						insadd=fc.definition.entities.add_instance(defn,trans*s)
						v3_tmp=v4.transform Geom::Transformation.translation v1_v2
						vector=v3_tmp.vector_to(v3)
						S4U::S4u_toComponents.skew(insadd,vector)
						insadd.transformation= transfc.inverse*insadd.transformation
						de=insadd.definition.entities[0].definition
						insadd.definition.entities[0].explode
						de.entities.clear!
						de=insadd.definition
						insadd.explode
						de.entities.clear!
						defn.entities.clear!
					end
				}
			end
		end #end class
		class FaceCom
			attr_accessor :xaxis,:yaxis,:zaxis,:origin,:definition,:vertices,:face,:instance,:origin_index,:unit_ver,:rever
			attr_reader :numver,:vx,:vy,:polygon,:parallel
			def initialize(face)
				@face=face
				@instance=nil
				@vertices=self.get_vertices
				@numver=@vertices.length
				@origin_index=0
				@origin=@vertices[0].position
				@zaxis=@face.normal
				cp=self.polygon?
				@parallel=self.parallel?
				@origin=cp if @polygon and (@numver>4)
				@unit_ver=[]
				@rever=0
				@strings=S4U::S4u_toComponents::Strings
				self.setvar(true)
			end
			def get_vertices
				ver=[]
				vertices=[]
				vertices =@face.vertices*3
				(0..@face.vertices.length-1).each { |i|
					j=@face.vertices.length+i
					p1=vertices[j-1].position.clone
					p2=vertices[j].position.clone
					p3=vertices[j+1].position.clone
					v1=p1.vector_to p2
					v2=p2.vector_to p3
					ver.push vertices[j] if not( v1.samedirection? v2)
				}
				return ver
			end
			def get_unit_ver
				ents=Sketchup.active_model.active_entities
				g=ents.add_group
				trans=Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
				g.transformation=trans
				vers=[]
				vers=@vertices.collect{|v| v.position.transform trans.inverse}
				gf=g.entities.add_group
				f=gf.entities.add_face vers
				f.reverse!
				gf=S4U::S4u_toComponents.scale_unit(gf,100)
				gf.explode
				ver=[]
				g.entities.each{|f|
					if f.is_a?Sketchup::Face
						ver=f.vertices.collect{|v| v.position}
					end
				}
				ents.erase_entities g
				@unit_ver[@origin_index+ @rever*@numver]=ver
				return ver
			end
			def setvar(first=false)
				if (@numver==4  and self.parallel?) or @numver==3
					@origin=@vertices[0].position
					@xaxis=@origin.vector_to @vertices[1].position
					@yaxis=@origin.vector_to @vertices[@numver-1].position
				else
					if @polygon
						@xaxis=@origin.vector_to @vertices[0].position
						@xaxis=@origin.vector_to @vertices[1].position if @xaxis.length==0
					else
						@origin=@vertices[0].position
						@xaxis=@origin.vector_to @vertices[1].position
					end
					@yaxis=@zaxis.cross @xaxis
					vy=@origin.vector_to @vertices[@numver-1].position
					@yaxis.reverse! if(@yaxis.angle_between vy)> (Math::PI/ 2)
					self.get_unit_ver if not @polygon and not first
				end
			end
			def draw_origin(view,start=false)
				size = view.pixels_to_model 50,[1,1,1]
				vecx=@xaxis
				vecy=@yaxis
				lx = @origin.distance @vertices[1].position
				if @numver==4 or @numver==3
					ly = @origin.distance @vertices[@numver-1].position
				else
					ly=lx
				end
				vecx.length=size
				vecy.length=size
				vecx.length = lx if (size > lx) #|| (size<1)
				vecy.length = ly if (size > ly) #|| (size<1)
				@vx=@origin,(@origin.transform Geom::Transformation.translation vecx)
				@vy=@origin,(@origin.transform Geom::Transformation.translation vecy)
				view.line_width=5
				view.drawing_color="red"
				view.draw_line @vx
				view.drawing_color="green"
				view.draw_line @vy
				view.drawing_color= start ?  "Orange" : "blueviolet"
				view.draw_line @vx[1],@vy[1]
			end
			def next_origin
				@origin_index=@origin_index+1
				@origin_index=@origin_index.divmod(4)[1]
				vers=@vertices*2
				@vertices.clear
				@vertices=vers[1..@numver]
				self.setvar
			end
			def reverse_axis
				@rever=1-@rever
				@vertices=@vertices[1..(@numver-1)].reverse.unshift @vertices[0]
				setvar
			end
			def set_origin(index)
				vers=@vertices*2
				length=@vertices.length+index-1
				@vertices.clear
				@vertices=vers[index..length]
				setvar
			end
			def polygon?
				cp1=self.center_face
				@polygon=true
				(1..@numver-1).each{|i|
					if (cp1.distance @vertices[0].position) != (cp1.distance @vertices[i].position)
						@polygon=false
						return nil
					end
				}
				return cp1 if @polygon
			end
			def parallel?
				if  @numver==4
					vers=@vertices
					v1=vers[0];v2=vers[1];v3=vers[2];vend=vers[3]
					vend_v3=vend.position.vector_to v3.position
					vx = v1.position.vector_to v2.position
					vy = v1.position.vector_to vend.position
					return true if (vend_v3.samedirection? vx and vend_v3.length==vx.length)
				end
				return false
			end
			def add_polygon
				model=Sketchup.active_model
				ents=model.active_entities
				insadd=nil
				if @definition
					if @polygon   #regular polygon
						dist=@origin.distance @vertices[0].position
						@unit_polygon=2*dist if !@unit_polygon
						dx= dist/ @unit_polygon
						trans= Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
						insadd=ents.add_instance(@definition,trans*Geom::Transformation.scaling(dx,dx,1))
					else	#polygon
						t = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
						gtmp=ents.add_group
						gtmp.transformation=t
						vers=@vertices.collect{|v| v.position.transform t.inverse}
						facetmp=gtmp.entities.add_face vers
						facetmp.reverse!
						sx=facetmp.bounds.width/ @definition.bounds.width
						sy=facetmp.bounds.height/ @definition.bounds.height
						s= Geom::Transformation.scaling(sx,sy,1)
						insadd=ents.add_instance(@definition,t*s)
						ents.erase_entities gtmp
					end
				end
				insadd.material = @face.material ? @face.material: @face.back_material
				@instance=insadd
				return @instance
			end
			def insert_instance(defn=@definition,width_bounds=nil,height_bounds=nil)
				ents=Sketchup.active_model.active_entities
				if self.parallel?  or @numver==3
					v1=@vertices[0].position;v2=@vertices[1].position
					vend=@vertices[@numver-1].position
					v1v2=v1.distance v2
					v1vend=v1.distance vend
					dx= v1v2/ (defn.bounds.width >0 ? defn.bounds.width : 1)
					dy =v1vend/ (defn.bounds.height >0 ? defn.bounds.height : 1)
					trans = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
					s=Geom::Transformation.scaling(dx,dy,1)
					insadd=ents.add_instance(defn,trans*s)
					insadd.material = @face.material ? @face.material: @face.back_material
					de=insadd.definition
					e=insadd.explode.grep(Sketchup::ComponentInstance)
					if e[0]
						@definition=e[0].definition
						@instance=e[0]
					end
				else
					if @numver==4
						t = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
						gtmp=ents.add_group
						gtmp.transformation=t
						vers=@vertices.collect{|v| v.position.transform t.inverse}
						facetmp=gtmp.entities.add_face vers
						facetmp.reverse!
						x=gtmp.local_bounds.width;y=gtmp.local_bounds.height
						ents.erase_entities gtmp
						dx= width_bounds ? width_bounds : (defn.bounds.width >0 ? defn.bounds.width : 1)
						dy= height_bounds ? height_bounds : (defn.bounds.height >0 ?defn.bounds.height : 1)
						sx=x/ dx
						sy=y/ dy
						s= Geom::Transformation.scaling(sx,sy,1)
						insadd=ents.add_instance(defn,t*s)
						@definition=defn
						@instance=insadd
					end
				end
				return @instance
			end
			def create_ins(defn=@definition)
				ents=Sketchup.active_model.active_entities
				if @numver==4 and not self.parallel?
				v1=@vertices[0].position;v2=@vertices[1].position
				v3=@vertices[2].position;v4=@vertices[3].position
				v1v2=v1.distance v2
				v1v4=v1.distance v4
				v1_v2 =v1.vector_to v2
				vx=v1.vector_to v2
				vy=v1.vector_to v4
				dx = v1v2/ (defn.bounds.width >0 ? defn.bounds.width : 1)
				dy = v1v4/ (defn.bounds.height >0 ?defn.bounds.height : 1)
				trans = Geom::Transformation.new(vx,vy,@zaxis,v1)
				trans1 = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
				s=Geom::Transformation.scaling(dx,dy,1)
				insadd=ents.add_instance(defn,trans*s)
				v3_tmp=v4.transform Geom::Transformation.translation v1_v2
				vector=v3_tmp.vector_to v3
				insadd1=S4U::S4u_toComponents.skew(insadd,vector)
				e=insadd1.definition.entities[0].definition
				insadd1.definition.entities[0].explode
				e.entities.clear!
				t=insadd.transformation
				g=ents.add_group insadd
				g.transformation=trans1
				insadd.transformation=trans1.inverse*t
				de=insadd.definition
				insadd.explode
				de.entities.clear!
				gg=g.to_component
				@definition=gg.definition
				@instance=gg
				gtmp=ents.add_group
				gtmp.transformation=trans1
				vers=@vertices.collect{|v| v.position.transform trans1.inverse}
				facetmp=gtmp.entities.add_face vers
				facetmp.reverse!
				b=gtmp.local_bounds
				ents.erase_entities gtmp
				end
				return [@instance,b]
			end
			def add_ins  #  triangle or quadrangle
				model=Sketchup.active_model
				ents=model.active_entities
				defn=@definition
				insadd=nil
				if defn
					if (@numver==4 and self.parallel?) or @numver==3
						v1=@vertices[0].position;v2=@vertices[1].position
						vend=@vertices[@numver-1].position
						v1v2=v1.distance v2
						v1vend=v1.distance vend
						dx= v1v2/ (defn.bounds.width >0 ? defn.bounds.width : 1)
						dy =v1vend/ (defn.bounds.height >0 ?defn.bounds.height : 1)
						trans = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
						s=Geom::Transformation.scaling(dx,dy,1)
						insadd=ents.add_instance(defn,trans*s)
					else
						t = Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
						gtmp=ents.add_group
						gtmp.transformation=t
						vers=@vertices.collect{|v| v.position.transform t.inverse}
						facetmp=gtmp.entities.add_face vers
						facetmp.reverse!
						sx=facetmp.bounds.width/ (defn.bounds.width >0 ? defn.bounds.width : 1)
						sy=facetmp.bounds.height/ (defn.bounds.height >0 ?defn.bounds.height : 1)
						s= Geom::Transformation.scaling(sx,sy,1)
						insadd=ents.add_instance(defn,t*s)
						ents.erase_entities gtmp
					end
				end
				insadd.material = @face.material ? @face.material: @face.back_material
				@instance=insadd
				return @instance
			end
			def center_face
				cp=Geom::Point3d.new
				@vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ @numver
				cp.y=cp.y/ @numver
				cp.z=cp.z/ @numver
				return cp
			end
		end #end class
		def self.groupstocoms
			model=Sketchup.active_model
			ents=model.active_entities
			sel=model.selection
			ins=nil
			groups=[]
			groups=sel.select{|e| e.is_a?Sketchup::Group}
			comps=sel.select{|e| e.is_a?Sketchup::ComponentInstance}
			ins=(comps.sort_by{|e| (comps.find_all{|e1| e1.definition==e.definition }).length }).last
			if groups.empty?
				UI.messagebox(Strings["Selection must contain Group(s)."])
				return nil
			end
			model.start_operation(Strings["Group to Components"],true,false,false)
			if ins
				tmp=ents.add_instance ins.definition,Geom::Transformation.new
				tmpgroup=self.create_group(tmp,"center")
				tmpins=tmpgroup.to_component
			else
				grp=groups.collect{|e| e.entities.parent }
				parent=grp.sort_by{|e| (grp.find_all{|e1| e1==e }).length }.last
				tmp=ents.add_instance parent,Geom::Transformation.new
				tmp=tmp.to_component if tmp.is_a?Sketchup::Group
				tmpgroup1=self.create_group(tmp,"center")
				tmpins=tmpgroup1.to_component
			end
			sel.clear
			groups.each {|g|
				x=1;y=1;z=1
				(x=g.local_bounds.width  / tmpins.definition.entities[0].definition.bounds.width) if tmpins.definition.entities[0].definition.bounds.width !=0
				(y=g.local_bounds.height / tmpins.definition.entities[0].definition.bounds.height) if tmpins.definition.entities[0].definition.bounds.height!=0
				(z=g.local_bounds.depth  / tmpins.definition.entities[0].definition.bounds.depth)  if tmpins.definition.entities[0].definition.bounds.depth !=0
				#x=1 if x==0;y=1 if y==0;z=1 if z==0;
				t=Geom::Transformation.new(g.local_bounds.center)
				s=Geom::Transformation.scaling(x,y,z)
				trans= g.transformation*t*s
				ins1=ents.add_instance( tmpins.definition,trans)
				ins=ins1.explode.grep(Sketchup::ComponentInstance)[0]
				if ins && ins.is_a?(Sketchup::ComponentInstance)
					ins.material= g.material if g.material
					ins.layer= g.layer if g.layer
					sel.add ins
				end
				ents.erase_entities g
			}

			de=tmpins.definition
			ents.erase_entities tmpins
			de.entities.clear! if ins
			model.commit_operation
			rescue =>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		def self.objectstocoms
			model=Sketchup.active_model
			ents=model.active_entities
			sel=model.selection
			ins=nil
			groups=[]
			groups=sel.select{|e| e.is_a?Sketchup::Group}
			comps=sel.select{|e| e.is_a?Sketchup::ComponentInstance}
			ins=(comps.sort_by{|e| (comps.find_all{|e1| e1.definition==e.definition }).length}).last
			if groups.empty? and comps.empty?
				UI.messagebox(Strings["Selection must contain Groups or Components."])
				return nil
			end
			model.start_operation(Strings["Objects to Components"],true,false,false)
			if ins
				tmp=ents.add_instance ins.definition,Geom::Transformation.new
				tmpgroup=self.create_group(tmp,"center")
				tmpins=tmpgroup.to_component
			else
				grp=groups.collect{|e| e.entities.parent }
				parent=grp.sort_by{|e| (grp.find_all{|e1| e1==e }).length }.last
				tmp=ents.add_instance parent,Geom::Transformation.new
				tmp=tmp.to_component if tmp.is_a?Sketchup::Group
				tmpgroup1=self.create_group(tmp,"center")
				tmpins=tmpgroup1.to_component
			end
			sel.clear
			groups.each {|g|
				x=1;y=1;z=1
				(x=g.local_bounds.width  / tmpins.definition.entities[0].definition.bounds.width) if tmpins.definition.entities[0].definition.bounds.width !=0
				(y=g.local_bounds.height / tmpins.definition.entities[0].definition.bounds.height) if tmpins.definition.entities[0].definition.bounds.height!=0
				(z=g.local_bounds.depth  / tmpins.definition.entities[0].definition.bounds.depth)  if tmpins.definition.entities[0].definition.bounds.depth !=0
				#x=1 if x==0;y=1 if y==0;z=1 if z==0;
				t=Geom::Transformation.new(g.local_bounds.center)
				s=Geom::Transformation.scaling(x,y,z)
				trans= g.transformation*t*s
				ins1=ents.add_instance( tmpins.definition,trans)
				ins=ins1.explode.grep(Sketchup::ComponentInstance)[0]
				if ins && ins.is_a?(Sketchup::ComponentInstance)
					ins.material= g.material if g.material
					ins.layer= g.layer if g.layer
					sel.add ins
				end
				ents.erase_entities g
			}
			comps.each {|g|
				x=1;y=1;z=1
				bounds=S4U::S4u_toComponents.get_bounds(g)[0]
				e=tmpins.definition.entities[0]
				defn= e.is_a?(Sketchup::ComponentInstance) ? e.definition : e.entities[0].parent
				(x= bounds[0] / defn.bounds.width) if defn.bounds.width !=0
				(y= bounds[1] / defn.bounds.height) if defn.bounds.height!=0
				(z= bounds[2] / defn.bounds.depth)  if defn.bounds.depth !=0
				tg=g.transformation
				t=Geom::Transformation.new(tg.xaxis,tg.yaxis,tg.zaxis,g.bounds.center)
				s=Geom::Transformation.scaling(x,y,z)

				ins1=ents.add_instance( tmpins.definition,t*s)
				ins=ins1.explode.grep(Sketchup::ComponentInstance)[0]
				if ins && ins.is_a?(Sketchup::ComponentInstance)
					ins.material= g.material if g.material
					ins.layer= g.layer if g.layer
					model.selection.add ins
				end
				ents.erase_entities g
			}
			de=tmpins.definition
			ents.erase_entities tmpins
			de.entities.clear! if ins
			model.commit_operation
			rescue =>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		def self.replace(components,definition,text="Replace Components")
			model=Sketchup.active_model
			ents=model.active_entities
			model.start_operation(Strings.GetString(text),true,false,false)
			if definition
				tmp=ents.add_instance definition,Geom::Transformation.new
				tmpgroup=S4U::S4u_toComponents.create_group(tmp,"center")
				tmpins=tmpgroup.to_component
			else
				return
			end
			model.selection.clear
			components.each {|g|
				x=1;y=1;z=1
				bounds=S4U::S4u_toComponents.get_bounds(g)[0]
				e=tmpins.definition.entities[0]
				defn= e.is_a?(Sketchup::ComponentInstance) ? e.definition : e.entities[0].parent
				(x= bounds[0] / defn.bounds.width) if defn.bounds.width !=0
				(y= bounds[1] / defn.bounds.height) if defn.bounds.height!=0
				(z= bounds[2] / defn.bounds.depth)  if defn.bounds.depth !=0
				tg=g.transformation
				t=Geom::Transformation.new(tg.xaxis,tg.yaxis,tg.zaxis,g.bounds.center)
				s=Geom::Transformation.scaling(x,y,z)

				ins1=ents.add_instance( tmpins.definition,t*s)
				ins=ins1.explode.grep(Sketchup::ComponentInstance)[0]
				if ins && ins.is_a?(Sketchup::ComponentInstance)
					ins.material= g.material if g.material
					ins.layer= g.layer if g.layer
					model.selection.add ins
				end
				ents.erase_entities g
			}
			de=tmpins.definition
			ents.erase_entities tmpins
			de.entities.clear! if definition
			model.commit_operation
			rescue =>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		class Select_element
			def initialize
				@cursor_id = nil
				cursor_path = File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
				@cursor_id = UI.create_cursor(cursor_path, 0, 0) if cursor_path
			end
			def activate()
				model=Sketchup.active_model
				ents=model.active_entities
				sel=model.selection
				@components=[]
				@components=sel.select{|e| e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group) }
				if @components.empty?
					UI.messagebox(Strings["Selection must contain Component(s)."])
					Sketchup.active_model.select_tool nil
				end
				setstatus()
			end
			def onSetCursor
				UI.set_cursor(@cursor_id) if @cursor_id
			end
			def onLButtonUp(flags, x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				ip = view.inputpoint x, y
				e=ip.face || ip.edge
				entity = ph.best_picked
				definition=nil
				if entity.is_a?(Sketchup::ComponentInstance)
					definition = entity.definition
				elsif entity.is_a?(Sketchup::Group)
					definition = entity.entities[0].parent
				end
				definition = e.parent if !definition && e && e.parent.is_a?(Sketchup::ComponentDefinition) && e.parent
				if definition
					comps=@components.select{|e| (e.is_a?(Sketchup::ComponentInstance) && (e.definition != definition)) || e.is_a?(Sketchup::Group)}
					S4U::S4u_toComponents::replace(comps,definition)
					Sketchup.active_model.select_tool nil
				end
			end
			def onMouseMove(flags, x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				entity = ph.best_picked
				name=""
				definition=nil
				if entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group)
					name += entity.name.length==0 ? "" : Strings.GetString("Name: ")  + entity.name + " - "
					definition = entity.is_a?(Sketchup::ComponentInstance) ? entity.definition : entity.entities[0].parent
				end
				ip = view.inputpoint x, y
				e=ip.face || ip.edge
				definition = e.parent if !definition && e && e.parent.is_a?(Sketchup::ComponentDefinition) && e.parent
				if definition
					s =(definition.group? ? Strings.GetString("Group") : Strings.GetString("Component")) + " - "  + name  +  Strings.GetString("Definition: ")  + definition.name
					view.tooltip = s
					setstatus s
					view.invalidate
				end
			end
			def setstatus(text="")
				s=Strings["Select Target Component: "] + text
				Sketchup::set_status_text s
			end
			def resume(view)
				setstatus()
			end
		end
		def self.linetocom(li,defn,ents,sort)
			line_start=li.start.position
			line_end=li.end.position
			inshtz=defn.bounds.depth >0 ? defn.bounds.depth : 1
			g=ents.add_group
			tedit=axes_edit_transform
			cp=line_start
			yaxis=nil
			vectoredge= line_start.vector_to line_end
			if sort
				if vectoredge.perpendicular? tedit.zaxis
					if line_start.y>line_end.y
						vectoredge.reverse!
						cp=line_end
					end
					if (line_start.x>line_end.x) && (line_start.y==line_end.y )
						vectoredge.reverse!
						cp=line_end
					end
				else
					if line_start.z>line_end.z
						vectoredge.reverse!
						cp=line_end
					end
				end
				sel=Sketchup.active_model.selection.to_a
				fs=li.faces & sel
				if fs.length>0
					if fs.length==1
						yaxis=fs[0].normal
					else
						yaxis=Geom::Vector3d.new(0,0,0)
						fs.each{|e| yaxis+=e.normal}
					end
				end

			end
			tmpinshtz=li.length
			sz= tmpinshtz / inshtz
			sz=1 if sz==0
			s= Geom::Transformation.scaling(1,1,sz)
			if yaxis && yaxis.length!=0 && (xaxis=yaxis.cross(vectoredge)) && xaxis.length!=0
				t= Geom::Transformation.new xaxis,yaxis,vectoredge,cp
			else
				t= Geom::Transformation.new cp,vectoredge
			end
			insadd=g.entities.add_instance defn,t*s
			insadd.layer=li.layer if li.layer
			return g.explode.find{|e| e.is_a?(Sketchup::ComponentInstance)}
		end
		def self.linestocoms(sortflag=false)
			model=Sketchup.active_model
			ents=model.active_entities
			sel=model.selection
			model.start_operation(Strings["Lines to Components"],true,false,false)
			if sel.length==0
			  UI.messagebox(Strings["Select Component Instance and Line(s)."])
			  return nil
			end
			lines=[]
			ins=fa=group=group_ins=tmpgrp=nil
			i=flag=0
			ins=sel.grep(Sketchup::ComponentInstance)[0]
			if not ins
				g=sel.grep(Sketchup::Group)[0]
				ins=g.to_component if g
			end
			if not ins
				fa=sel.grep(Sketchup::Face)[0]
				if fa
					(sel=sel.to_a-[fa]- fa.edges)
					flag=1
				end
			end
			sel.each{|e| e.curve.first_edge.explode_curve if e.is_a?(Sketchup::Edge) and e.curve}
			lines=sel.select{|e| e.is_a?(Sketchup::Edge) and not e.curve}
			if lines.empty?
				UI.messagebox(Strings["Selection must contain line(s)."])
				model.abort_operation
				return nil
			end
			if ins==nil
				unit=lines[0].length
				if flag==1
					group = ents.add_group
					tmpgrp=ents.add_group fa
					new_transform = Geom::Transformation.new(tmpgrp.bounds.center,fa.normal)
					group.transformation=new_transform
					inst=group.entities.add_instance(tmpgrp.entities.parent,new_transform.inverse)
					inst.explode
					tmpgrp.explode
					faceingrp=group.entities.grep(Sketchup::Face)[0]
					faceingrp.pushpull unit
					group1=self.create_group(group,"bottom")
					group.explode
					ins=group1.to_component
				else
					tmpgroup=ents.add_group
					tmpgroup.entities.add_line Geom::Point3d.new(0,0,0),Geom::Point3d.new(0,0,unit)
					ins=tmpgroup.to_component
					flag=2
				end
			end
			if flag==0
				ins1=ents.add_instance(ins.definition,self.axes_edit_transform)
				tmpgroup=self.create_group(ins1,"bottom")
				tmpins=tmpgroup.to_component
				defn=tmpins.definition
			else
				defn=ins.definition
			end
			lines.each{|l|
				if l.valid?
					tmp=self.linetocom(l,defn,ents,sortflag)
					tmp.explode if flag==0 && tmp
				end
			}
			#lines.each{|l|  l.erase! if l.valid? and l.is_a?Sketchup::Edge and l.faces.length==0}
			ents.erase_entities ins if(flag==1 or flag==2 )
			defn.entities.clear! if flag==0
			model.commit_operation
			return true
			rescue =>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		def self.pointtocom(li,defn,ents)
			line_start=li.position.clone
			t= Geom::Transformation.new line_start
			insadd=ents.add_instance defn,t
			insadd.layer=li.layer if li.layer
			return insadd
		end
		def self.pointstocoms()
			model=Sketchup.active_model
			ents=model.active_entities
			sel=model.selection
			model.start_operation(Strings["Points to Components"],true,false,false)
			if sel.length==0
			  UI.messagebox(Strings["Select ConstructionPoints and Component(or face)"])
			  return nil
			end
			points=[]
			ins=fa=group=group_ins=tmpgrp=ed=nil
			i=flag=0
			ins=sel.grep(Sketchup::ComponentInstance)[0]
			if not ins
				g=sel.grep(Sketchup::Group)[0]
				ins=g.to_component if g
			end
			#if ins and ins.definition.bounds.depth==0
				#UI.messagebox(Strings.GetString("Components must have heigth>0"))
				#return nil
			#end
			if not ins
				fa=sel.grep(Sketchup::Face)[0]
				if fa
					(sel=sel.to_a-[fa]- fa.edges)
					flag=1
				else
					ed=sel.grep(Sketchup::Edge)[0]
				end
			end
			points=sel.select{|e| e.is_a?(Sketchup::ConstructionPoint)}
			if points.empty?
				UI.messagebox(Strings["Selection must contain Construction Points"])
				model.abort_operation
				return nil
			end
			if !ins && !fa && !ed
				UI.messagebox(Strings["Selection must contain Component(or face)"])
				model.abort_operation
				return nil
			end
			if ins==nil

				if flag==1
					group = ents.add_group
					tmpgrp=ents.add_group fa
					new_transform = Geom::Transformation.new(tmpgrp.bounds.center,fa.normal)
					group.transformation=new_transform
					inst=group.entities.add_instance(tmpgrp.entities.parent,new_transform.inverse)
					inst.explode
					tmpgrp.explode
					group1=self.create_group(group,"bottom")
					group.explode
					ins=group1.to_component
				elsif ed
					unit=ed.length
					tmpgroup=ents.add_group
					tmpgroup.entities.add_line Geom::Point3d.new(0,0,0),Geom::Point3d.new(0,0,unit)
					ins=tmpgroup.to_component
					flag=2
				end
			end
			if flag==0
				ins1=ents.add_instance(ins.definition,self.axes_edit_transform)
				tmpgroup=self.create_group(ins1,"bottom")
				tmpins=tmpgroup.to_component
				defn=tmpins.definition
			else
				defn=ins.definition
			end
			points.each{|l|
				if l.valid?
					tmp=self.pointtocom(l,defn,ents)
					tmp.explode if flag==0 && tmp
				end
			}
			ents.erase_entities ins if(flag==1 or flag==2)
			defn.entities.clear! if flag==0
			model.commit_operation
			return true
			rescue =>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		def self.create_group(object,z_origin=-1)
			model=Sketchup.active_model
			ents=model.active_entities
			t=object.transformation
			tt=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,t.origin)
			g=ents.add_group object
			g.transformation=tt
			object.transformation=tt.inverse*t
			t=object.transformation
			origin=object.bounds.min
			b=object.bounds
			center=object.bounds.center
			case z_origin
			when "min",0
				origin_new= [origin.x,origin.y,origin.z]
			when "center"
				origin_new= center
			when "bottom"
				origin_new= [center.x,center.y,origin.z]
			when "top"
				origin_new= [center.x,center.y,origin.z+b.depth]
			when 1
				origin_new= [origin.x+b.width,origin.y,origin.z]
			when 2
				origin_new= [origin.x,origin.y+b.height,origin.z]
			when 3
				origin_new= [origin.x+b.width,origin.y+b.height,origin.z]
			when 4
				origin_new= [origin.x,origin.y,origin.z+b.depth]
			when 5
				origin_new= [origin.x+b.width,origin.y,origin.z+b.depth]
			when 6
				origin_new= [origin.x,origin.y+b.height,origin.z+b.depth]
			when 7
				origin_new= [origin.x+b.width,origin.y+b.height,origin.z+b.depth]
			when "max_x"
				origin_new= [origin.x+b.width,origin.y,t.origin.z]
			when "max_y"
				origin_new= [origin.x,origin.y+b.height,t.origin.z]
			when "max_xy"
				origin_new= [origin.x+b.width,origin.y+b.height,t.origin.z]
			when "max"
				origin_new= [origin.x+b.width,origin.y+b.height,origin.z+b.depth]
			else  # move
				origin_new= [origin.x,origin.y,t.origin.z]
			end
			vec =t.origin.vector_to origin_new
			tv=Geom::Transformation.translation vec
			tnew=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,origin_new)
			object.transform! tnew.inverse
			g.transformation=g.transformation*tnew
			return g
		end
		def self.scale_unit(object,unit=1)
			w=object.local_bounds.width
			h=object.local_bounds.height
			t=Geom::Transformation.new([(unit/ w),0,0,0,0,(unit/ h),0,0,0,0,1,0,0,0,0,1])
			object.transformation = object.transformation*t
			return object
		end
		def self.get_entities(object)
			entities=nil
			if object.is_a?Sketchup::Group
				object.make_unique
				entities= object.entities
			else
				if object.is_a?Sketchup::ComponentInstance
					entities= object.definition.entities
				end
			end
			return entities
		end
		def self.getvertex(object,vector1,t)
			vector=vector1.transform object.transformation.inverse
			entities=nil
			entities=self.get_entities(object)
			lv=[];ed=[]
			entities.each{|e| ed << e.curve if (e.is_a?Sketchup::Edge) && e.curve && (!ed.include?(e.curve))}
			ed.uniq!
			ed.each{ |e| e.first_edge.explode_curve }
			entities=self.get_entities(object)
			elements=[];edges=[]
			entities.each{|e|
				if (e.is_a?Sketchup::ComponentInstance) || (e.is_a?Sketchup::Group )
					e.make_unique  if e.is_a?Sketchup::ComponentInstance
					elements<<e
				else
					edges<<e  if e.is_a?(Sketchup::Edge)
				end
			}
			edges.each{|e|
				e.vertices.each{|ve1|
					next if lv.include?(ve1)
					ve=ve1.position.clone
					ve=ve.transform t*object.transformation
					lv.push ve1 if (ve.x!=0) && (ve.y!=0)
				}
			}
			lv.uniq!
			sub_entities =[]
			vector_array =[]
			lv.each{|ve1|
				ve=ve1.position.clone
				ve=ve.transform t*object.transformation
				vec_ve=vector.clone
				vec_ve.z=0
				sx=(ve.x/ @max.x).abs
				sy=(ve.y/ @max.y).abs
				vec_ve.x=vector.x*sx*sy
				vec_ve.y=vector.y*sx*sy
				sub_entities.push ve1
				vector_array.push vec_ve
			}
			@ents<< entities
			@sub_entities<<  sub_entities
			@vector_array<<  vector_array
			elements.each{|e|
				t1=t*object.transformation
				self.getvertex(e,vector,t1)
			}
		end
		def self.skew(object,vector1)
			@ents=[]
			@sub_entities=[]
			@vector_array=[]
			model=Sketchup.active_model
			ents=model.active_entities
			vector=vector1.transform object.transformation.inverse
			entities=nil
			if object.is_a?Sketchup::Group
				object.make_unique
				entities= object.entities
				bound=object.local_bounds
			else
				if object.is_a?Sketchup::ComponentInstance
					entities= object.definition.entities
					bound=object.definition.bounds
				end
			end
			@max=bound.min.vector_to bound.max
			lv=[];ed=[]
			entities.each{|e| ed << e.curve if (e.is_a?Sketchup::Edge) && e.curve && (not ed.include?(e.curve))}
			ed.uniq!
			ed.each{ |e| e.first_edge.explode_curve  }
			entities=self.get_entities(object)
			elements=[];edges=[]
			entities.each{|e|
				if (e.is_a?Sketchup::ComponentInstance) || (e.is_a?Sketchup::Group )
					e.make_unique  if e.is_a?Sketchup::ComponentInstance
					elements<< e
				else
					edges<<e  if e.is_a?(Sketchup::Edge)
				end
			}
			edges.each{|e|
				e.vertices.each{|ve1|
					next if lv.include?(ve1)
					ve=ve1.position.clone
					lv.push ve1 if ve.x!=0 && ve.y!=0
				}
			}
			lv.uniq!
			sub_entities =[]
			vector_array =[]
			lv.each{|ve1|
				ve=ve1.position.clone
				vec_ve=vector.clone
				vec_ve.z=0
				sx=(ve.x/ @max.x).abs
				sy=(ve.y/ @max.y).abs
				vec_ve.x=vector.x*sx*sy
				vec_ve.y=vector.y*sx*sy
				sub_entities.push ve1
				vector_array.push vec_ve
			}
			@ents<< entities
			@sub_entities<<  sub_entities
			@vector_array<<  vector_array
			elements.each{|e|
				t=Geom::Transformation.new
				self.getvertex(e,vector,t)
			}
			(0..@ents.length-1).each{|i|
				@ents[i].transform_by_vectors @sub_entities[i], @vector_array[i]
			}
			return object
		end
		def self.get_vertices_uv(fc)
			tw = Sketchup.create_texture_writer
			uv_helper = fc.face.get_UVHelper true, true, tw
			vers={}
			fc.vertices.each do |vert|
				uvq = uv_helper.get_front_UVQ(vert.position)
				vers[vert]=[]
				vers[vert].push uvq.x,uvq.y
			end
			v1=vers.sort{|a,b| (a[1][1] <=> b[1][1]) }
			v2=v1[0..1]
			v2.sort!{|a,b| (a[1][0] <=> b[1][0]) }
			return v2[0][0],v2[1][0]
		end
		def self.axes_edit_transform
			model=Sketchup.active_model
			return model.axes.transformation
		end
		def self.texture_facecom(fc)
			model=Sketchup.active_model
			ents=model.active_entities
			vers=self.get_vertices_uv(fc)
			fc.set_origin(fc.vertices.index(vers[0]))
			if (fc.vertices[1] != vers[1]) && (fc.vertices[0]==vers[0])
				fc.reverse_axis
			end
			return fc
		end
		def self.arrange_facecom(fc)
			model=Sketchup.active_model
			ents=model.active_entities
			face=fc.face
			t=self.axes_edit_transform
			vectorz= t.zaxis
			if fc.face.normal.parallel? vectorz
				vers=fc.vertices.sort{|a,b| (a.position.transform t).y <=> (b.position.transform t).y}
				if ((vers[0].position.transform t).x < (vers[1].position.transform t).x ) ||
				((vers[0].position.transform t).x == (vers[1].position.transform t).x && (vers[0].position.transform t).y <= (vers[1].position.transform t).y)
					index= fc.vertices.index(vers[0])
				else
					index= fc.vertices.index(vers[1])
				end
				fc.set_origin(index)  if index !=fc.origin_index
				fc.reverse_axis if (fc.xaxis.normalize.transform t).y > (fc.yaxis.normalize.transform t).y
				if (fc.xaxis.normalize.transform t).x < 0
					fc.next_origin
					fc.reverse_axis if (fc.xaxis.normalize.transform t).y > (fc.yaxis.normalize.transform t).y
				end
			else
				vers =fc.vertices.sort{|a,b| (a.position.transform t).z <=> (b.position.transform t).z}
				if ((vers[0].position.transform t).x < (vers[1].position.transform t).x ) ||
				((vers[0].position.transform t).x == (vers[1].position.transform t).x && (vers[0].position.transform t).y <= (vers[1].position.transform t).y)
					index= fc.vertices.index(vers[0])
				else
					index= fc.vertices.index(vers[1])
				end
				fc.set_origin(index) if index != fc.origin_index
				fc.reverse_axis if (fc.xaxis.normalize.transform t).z > (fc.yaxis.normalize.transform t).z
			end
			return fc
		end
		def self.minline_facecom(fc)
			model=Sketchup.active_model
			ents=model.active_entities
			face=fc.face
			vers =fc.vertices.clone
			vers.unshift fc.vertices[-1]
			ver=[vers[0],vers[1]]
			length=ver[0].position.distance(ver[1].position)
			ver=[vers[0],vers[1]]
			(1..vers.length-2).each{|i|
				if vers[i].position.distance(vers[i+1].position)<length
					ver=[vers[i],vers[i+1]]
					length=ver[0].position.distance(ver[1].position)
				end
			}
			if vers
				index= fc.vertices.index(ver[0])
				fc.set_origin(index) if index != fc.origin_index
			end
			return fc
		end
		def self.angle_facecom(fc)
			model=Sketchup.active_model
			ents=model.active_entities
			face=fc.face
			vers =fc.vertices.clone
			vers<<fc.vertices[0]
			vers1=fc.vertices.sort_by{|v| (fc.vertices[fc.vertices.index(v)-1].position-fc.vertices[fc.vertices.index(v)].position).angle_between(
										(vers[fc.vertices.index(v)+1].position-fc.vertices[fc.vertices.index(v)].position))
									}
			if vers1[-1]
				index= fc.vertices.index(vers1[-1])
				fc.set_origin(index) if index != fc.origin_index

			end
			return fc
		end
		def self.get_bounds(element)
			a=element.transformation.to_a
			b=nil
			if element.is_a?Sketchup::ComponentInstance
				b=element.definition.bounds
			elsif element.is_a?Sketchup::Group
				b=element.local_bounds
			end
			if b
				corner= (0..7).collect{|i| b.corner(i).clone.transform! element.transformation }
				w=corner[0].distance corner[1]
				h=corner[0].distance corner[2]
				d=corner[0].distance corner[4]
				return [[w,h,d],corner[0],corner[7]]
			end
			return nil
		end
		def self.get_defn(ins,corner)
			model=Sketchup.active_model
			ents=model.active_entities
			g=ents.add_group
			trans=Geom::Transformation.rotation [0,0,0],[0,0,1],(-(corner)*Math::PI/ 2)
			tmpins1=g.entities.add_instance(ins.definition,trans)
			p=[g.local_bounds.min.x,g.local_bounds.min.y,tmpins1.transformation.origin.z]
			tv=Geom::Transformation.translation p
			tmpins1.transformation =tv.inverse*tmpins1.transformation
			tmpins= g.to_component
			defn=tmpins.definition
			ents.erase_entities tmpins
			return defn
		end
		def self.cut_elements(entities,plane,delete,cut_inside,section_type=0)
			g=nil
			cut_hide=delete
			if delete==-1 || delete==-2
				plane[0]=[plane[0][0],(Geom::Vector3d.new plane[0][1]).reverse]
				cut_hide=-delete
			end
			if entities.length>0
				g=Sketchup.active_model.active_entities.add_group entities
				cut_element(g,plane,cut_hide,cut_inside,section_type) if g && (g.is_a?Sketchup::Group) if g
				return g.explode if g && !g.deleted? && (g.is_a?Sketchup::Group)
			end
			return nil
		end
		def self.points_on_plane(points,plane)
			p1=points[0].clone;p2=points[1].clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			p2.transform! t_plane.inverse
			return (((p1.z>0) && (p2.z>=0)) || ((p1.z>=0) && (p2.z>0)))
		end
		def self.point_on_plane(point,plane)
			p1=point.clone
			t_plane=Geom::Transformation.new(plane[0],plane[1])
			p1.transform! t_plane.inverse
			return p1.z
		end
		def self.cut_element(element,planes,cut_hide,cut_inside,section_type,t=Geom::Transformation.new)
			plane=planes[0]
			plane1=planes[1]
			plane2=planes[2]
			result=true
			ent=nil
			on_plane=self.element_on_plane(element,plane,t)
			if on_plane==-1
				return true
			elsif on_plane==1
				element.erase! if cut_hide==1 || cut_hide==2
				return true
			end
			if element && (!element.deleted?)
				element.make_unique
				if element.is_a?Sketchup::Group
					ent=element.entities
				elsif element.is_a?Sketchup::ComponentInstance
					ent=element.definition.entities
				end
			end
			return if !ent
			noelements=ent.select{|e| !(e && (!e.deleted?) && ((e.is_a?Sketchup::Edge)||(e.is_a?Sketchup::Face)||(e.is_a?Sketchup::Group)||(e.is_a?Sketchup::ComponentInstance)))}
			begin
				ent.erase_entities noelements
			rescue
				p "don't delete noelements"
				result=false
			end
			faces=[];edges=[]
			groups=ent.select{|e| e && (!e.deleted?) && ((e.is_a?Sketchup::Group) || (e.is_a?Sketchup::ComponentInstance)) } if cut_inside==1
			faces=ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Face)}
			groups.each{|e| cut_element(e,planes,cut_hide,cut_inside,section_type,t*element.transformation) } if groups && groups.length>0
			faces.each{|e|
				points=[]
				e.edges.each{|ed|
					ps=ed.start.position.transform t*element.transformation
					pe=ed.end.position.transform  t*element.transformation
					p=Geom.intersect_line_plane([ps,pe], plane)
					(points<< p) if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
				}
				points=points.sort{|a,b| [a.x,a.y,a.z] <=> [b.x,b.y,b.z] }
				(0..points.length-2).each{|i|
					if points[i]!= points[i+1]
						p1=points[i].clone.transform((t*element.transformation).inverse)
						p2=points[i+1].clone.transform((t*element.transformation).inverse)
						pl=e.classify_point(Geom::Point3d.linear_combination(0.5,p1,0.5,p2))
						if (pl==1) || (pl==2) || (pl==4)
							ps=points[i]
							pe=points[i+1]
							if plane1 && plane2
								ps_on_plane = (point_on_plane(ps,plane1)>=0)
								pe_on_plane = (point_on_plane(pe,plane1)>=0)
								p1=p2=nil
								if points_on_plane([ps,pe],plane1)
									p1=ps;p2=pe
								elsif ps_on_plane || pe_on_plane
									point_plane=Geom.intersect_line_plane([ps,pe], plane1)
									if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
										if ps_on_plane
											p1=ps;p2=point_plane
										elsif pe_on_plane
											p1=point_plane;p2=pe
										end
									end
								end
								if p1 && p2
									ps=p1.clone
									pe=p2.clone
									p1=p2=nil
									ps_on_plane = (point_on_plane(ps,plane2)>=0)
									pe_on_plane = (point_on_plane(pe,plane2)>=0)
									if points_on_plane([ps,pe],plane2)
										p1=pe;p2=ps
									elsif (point_on_plane(ps,plane2)>=0)  || (point_on_plane(pe,plane2)>=0)
										point_plane=Geom.intersect_line_plane([ps,pe], plane2)
										if point_plane && (Geom.point_in_polygon_2D(point_plane,[ps,pe],true))
											if ps_on_plane
												p1=ps;p2=point_plane
											elsif pe_on_plane
												p1=point_plane;p2=pe
											end
										end
									end
									if p1 && p2
										p1=p1.transform((t*element.transformation).inverse)
										p2=p2.transform((t*element.transformation).inverse)
										edges << [p1,p2]
									end
								end
							else
								p1=ps.transform((t*element.transformation).inverse)
								p2=pe.transform((t*element.transformation).inverse)
								edges << [p1,p2]
							end
						end
					end
				}
			}
			edges_new=[]
			edges.each{|e|
				edge=ent.add_edges(e[0],e[1])
				if edge && edge[0] && (edge[0].is_a?Sketchup::Edge)
					edge[0].soft=true if cut_hide==1 || !cut_hide
					edges_new << edge[0]
				end
			}
			if section_type>0 && ent
				edges_new.uniq!
				edges1=edges_new.clone
				i=0;list=[]
				while (edges1.length>0) && (i<edges.length)
					ls=[]
					ls<< edges1.shift
					ls+= (ls[0].all_connected & edges1) -ls
					list<< ls
					edges1-=ls
					i+=1
				end
				begin
					gt= ent.add_group
					vertices_list=[]
					list.each{|pl|
						pl.compact!
						pl.uniq!
						pl1=pl.clone#*2
						vertices=[];c=0
						while (c<(pl.length)) && pl1.length>0
							c+=1
							ps=[];pse=[]
							pl1.each {|p| ps.push p.start,p.end }
							ps.uniq!
							pse<<ps[0]
							i=0
							while pse.length<=ps.length && (i< ps.length)
								ps.each_index{|j|
									(pse<< ps[j]) if (!(pse.include?(ps[j]))) && (pse.last.common_edge(ps[j]))
								 }
								i+=1
							end
							pse.uniq!
							(vertices<<(pse)) if (pse.length>2) && (pse.first.common_edge(pse.last))
							eds=[]
							pl1.each{|v1|
								eds<< v1 if pse.include?(v1.start) && pse.include?(v1.end) && (((v1.start.edges & pl1).length==2) || ((v1.end.edges & pl1).length==2))
							}
							eds.uniq!
							pl1-=eds
						end
						re = (vertices.flatten.length==pl.length) ? nil : pl
						vertices_list<< [vertices,re]
					}
					vertices_list.each{|vs|
						if !vs[1]
							vertices=vs[0]
							vers=[]
							vertices1=vertices.clone
							vertices.each{|v1|
								flag=true
								vertices.each{|v2|
									if (v1!=v2) && (v2.all?{|vi| Geom.point_in_polygon_2D(vi.position,(v1.collect{|p| p.position}), true)})
										flag=false
										break
									end
								}
								if flag
									vers<< [v1]
									vertices1-=[v1]
								end
							}
							(0..vers.length-1).each{|i|
								iv=0
								length=vertices1.length
								while vertices1.length>0 && iv<length
									iv+=1
									vertices1.each{|v1|
										if (vers[i].last.all?{|vi| Geom.point_in_polygon_2D(vi.position,(v1.collect{|p| p.position}), true)})
											if vers[i].length<1
												vers[i]<< v1
											else
												fl=true
												(0..vers[i].length-2).each{|ii|
													if vers[i][ii].all?{|vi| Geom.point_in_polygon_2D(vi.position,(v1.collect{|p| p.position}), true)}
														 if v1.all?{|vi| Geom.point_in_polygon_2D(vi.position,(vers[i][ii+1].collect{|p| p.position}), true)}
															 vers[i]=vers[i][0..ii] +[v1] + vers[i][ii+1..-1]
															 fl=false
														 end
													end
												}
												vers[i]<< v1 if fl
											end
											vertices1-=[v1]
											break
										end
									}
								end
							}
							vers.each{|vertices1|
								fs=[]
								vertices=vertices1.reverse
								(0..vertices.length-1).each{|i|
									if vertices[i].length>2
										f=gt.entities.add_face(vertices[i])
										if f && (f.is_a?Sketchup::Face)
											vec= f.normal.transform t*element.transformation
											f.reverse! if !(vec.samedirection?(plane[1]) || (vec.angle_between(plane[1])<(Math::PI*0.5)))
											fs<<f if i%2==1
										end
									end
								}
								fs.each_index{|i| fs[i].erase! if fs[i] && (!fs[i].deleted?) }
							}
						else
							eds=vs[1]
							eds.each{|e| gt.entities.add_edges(e.start.position,e.end.position)}
							ed=gt.entities.grep(Sketchup::Edge)
							ed.each{|ei| ei.find_faces}
							gt.entities.grep(Sketchup::Edge).each{|ei|
								ei.faces.each{|f|
									if f && (f.is_a?Sketchup::Face)
										vec= f.normal.transform t*element.transformation
										f.reverse! if !(vec.samedirection?(plane[1]) || (vec.angle_between(plane[1])<(Math::PI*0.5)))
									end
								}
							}
						end
					}
					gt.explode if section_type==2 && gt
				rescue
					puts "error element"
					result=false
				end
			end
			ent_edges=ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}

			addedges=[]
			ent_edges.each{|ed|
				ps=ed.start.position.transform t*element.transformation # world ucs t*element.transformation
				pe=ed.end.position.transform  t*element.transformation
				p=Geom.intersect_line_plane([ps,pe], plane)
				if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
					addedges<< p.transform((t*element.transformation).inverse)
				end
			}
			addedges.each{|ep| ent.add_line ep,ep}
			@count=0 if !@count
			Sketchup.status_text= Strings["Procesing level"] + ":#{@count}"
			@count+=1
			if (cut_hide==1) || (cut_hide==2)
				length_ent_edges=(ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge)}).length
				loop =0 ;j=0 ;length_ent_edges_new=0
				while (length_ent_edges != (length_ent_edges_new+j)) && (loop<5) do
					ent_edges=ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}
					addedges=[]
					ent_edges.each{|ed|
						ps=ed.start.position.transform t*element.transformation # world ucs t*element.transformation
						pe=ed.end.position.transform  t*element.transformation
						p=Geom.intersect_line_plane([ps,pe], plane)
						if p && (Geom.point_in_polygon_2D(p,[ps,pe],true))
							addedges<< p.transform((t*element.transformation).inverse)
						end
					}
					addedges.each{|ep| ent.add_line ep,ep}
					length_ent_edges=(ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}).length
					ver=[] ;ver1=[] ;ver_face=[]
					ent.each{|e|
						if e && (!e.deleted?) && (e.is_a?Sketchup::Face)
							e.edges.each{|ed|
								ps=ed.start.position.transform t*element.transformation
								pe=ed.end.position.transform  t*element.transformation
								ver_face<< ed if points_on_plane([ps,pe],plane)
							}
						end
					}
					ent.each{|e|
						if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && e.faces.length==0
							ps=e.start.position.transform t*element.transformation
							pe=e.end.position.transform t*element.transformation
							if points_on_plane([ps,pe],plane)
								if point_on_plane(ps,plane)==0 || point_on_plane(pe,plane)==0
									ver1<< e
								else
									ver<< e
								end
							end
						end
					}
					ver.uniq!
					ver1.uniq!
					j=0
					begin
						ver1.each{|e| (e.erase!;j+=1) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
						ver.each{|e|(e.erase!;j+=1) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
						ver_face.each{|e|(e.erase!) if e && (!e.deleted?) && (e.is_a?Sketchup::Edge) }
					rescue=>error
						p error
						result=false
					end
					loop+=1
					length_ent_edges_new=(ent.select{|e| e && (!e.deleted?) && (e.is_a?Sketchup::Edge) && (e.faces.length==0)}).length
				end
			end
			return result
			rescue=>error
			p error
			p error.backtrace.join("\n")
		end
		def self.element_on_plane(element,plane,t=Geom::Transformation.new)
			bounds=element.bounds
			corner=(0..7).collect{|i| bounds.corner(i).transform(t)}
			corner << bounds.center.transform(t)
			if corner.all?{|c| point_on_plane(c,plane)>0}
				return 1
			elsif corner.all?{|c| point_on_plane(c,plane)<0}
				return -1
			else
				return 0
			end
			rescue
			return 0
		end
		def self.main(mode=1)
			display_axis=true,arrange=false
			model=Sketchup.active_model
			case mode
			when 0
				S4U::S4u_toComponents.pointstocoms
			when 1
				S4U::S4u_toComponents.drawlinetocomponents
			when 2
				S4U::S4u_toComponents.linestocoms(false)
			when 3
				S4U::S4u_toComponents.linestocoms(true)
			when 4,"interact"
				model.select_tool S4U::S4u_toComponents::FacetoComponents.new(false,false)
			when 5,"display_axis"
				model.select_tool S4U::S4u_toComponents::FacetoComponents.new(true,false)
			when 6,"arrange"
				fcs=S4U::S4u_toComponents::FacetoComponents.new(false,true)
				fcs.setvar
			when 7,"uniform"
				fcs=S4U::S4u_toComponents::FacetoComponents.new(false,false,true)
				fcs.setvar
			when 8,"face_curver"
				model.select_tool S4U::S4u_toComponents::Face_com_curver.new
			when 9
				S4U::S4u_toComponents.groupstocoms
			when 10
				S4U::S4u_toComponents.objectstocoms
			when 11
				Sketchup.active_model.select_tool S4U::S4u_toComponents::Select_element.new
			end
		end
	end
end