# copyright= Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_toComponents
        IS_WIN = (Sketchup.platform == :platform_win)
		IS_OSX = (Sketchup.platform == :platform_osx)
		Sketchup::require File.join(NAME,"s4u_drawlinetocom_code")
		Sketchup::require File.join(NAME,(NAME + "_code"))
		if !self.const_defined?("Dir_s4u_name")
			S4U.instance_variable_set(:@s4u_menu,UI.menu("Plugins").add_submenu("Suforyou")) if !S4U.instance_variable_defined?(:@s4u_menu)
			menu=S4U.instance_variable_get :@s4u_menu
			submenu=menu.add_submenu(TOOL)
			@toolbar = UI::Toolbar.new("s4u-" + TOOL)
			names=[
					[Strings["Points to Components"],"points2coms",Strings["Select ConstructionPoints and Component(face)"]+'.'],
					[Strings["Draw Lines to Components"],"drawlines2coms",Strings["Select 1 Face or 1 Component"]+'.'],
					[Strings["Lines to Components"],"lines2coms",Strings["Select 1 Face(or 1 component) and Lines"]+'.'],
					[Strings["Lines to Components-Arrange"],"lines2coms1",Strings["Select 1 Face(or 1 component) and Lines-Arrange"]+'.'],
					[Strings["Faces to Components-Interact"],"faces2coms_interact",Strings["Select 1 Component and Faces(or Faces)"]+'.'],
					[Strings["Faces to Components"],"faces2coms",Strings["Select 1 Component and Faces(or Faces)"]+'.'],
					[Strings["Faces to Components-Arrange"],"faces2coms1",Strings["Select 1 Component and Faces(or Faces)-Arrange"]+'.'],
					[Strings["Faces to Components-Uniform"],"faces2coms2",Strings["Select 1 Component and Faces(or Faces)-Uniform"]+'.'],
					[Strings["FaceCurver to Components-Interact"],"curver_interact",Strings["Select 1 Component and FaceCurvers"]+'.'],
					[Strings["Groups to Components"],"groups2coms",Strings["Select 1 Component and Groups"]+'.'] ,
					[Strings["Objects to Components"],"objects2coms",Strings["Select Groups and Components"]+'.'],
					[Strings["Replace Components"],"coms2coms_interact",Strings["Select Components for replace"]+'.']
			]
			if IS_OSX
				names.each{|n| n[1]+=".pdf"}
			else
				names.each{|n| n[1]+=".svg"}
			end
			items=[]
			(0..names.length-1).each{|i|
				cmd=UI::Command.new(names[i][0]){ self.main(i) }
				cmd.large_icon = names[i][1]
				cmd.small_icon = names[i][1]
				cmd.status_bar_text = names[i][2]
				cmd.tooltip= names[i][0]
				cmd.menu_text = names[i][0]
				@toolbar=@toolbar.add_item cmd
				@toolbar.add_separator if i==3 || i==7
				items<<submenu.add_item(cmd)
			}
			@toolbar.show if @toolbar.get_last_state.abs == 1
            Dir_s4u_name = File.join(File.dirname(@ext.extension_path),NAME)
		end

	end
end